// Code generated by pigeon; DO NOT EDIT.

package nosql

import (
	"bytes"
	"errors"
	"fmt"
	"io"
	"math"
	"os"
	"sort"
	"strconv"
	"strings"
	"sync"
	"unicode"
	"unicode/utf8"

	"github.com/pikami/cosmium/parsers"
)

func makeSelectStmt(
	columns, fromClause, joinItems,
	whereClause interface{}, distinctClause interface{},
	count interface{}, groupByClause interface{}, orderList interface{},
	offsetClause interface{},
) (parsers.SelectStmt, error) {
	selectStmt := parsers.SelectStmt{
		SelectItems: columns.([]parsers.SelectItem),
	}

	if fromTable, ok := fromClause.(parsers.Table); ok {
		selectStmt.Table = fromTable
	}

	if joinItemsArray, ok := joinItems.([]interface{}); ok && len(joinItemsArray) > 0 {
		selectStmt.JoinItems = make([]parsers.JoinItem, len(joinItemsArray))
		for i, joinItem := range joinItemsArray {
			selectStmt.JoinItems[i] = joinItem.(parsers.JoinItem)
		}
	}

	switch v := whereClause.(type) {
	case parsers.ComparisonExpression, parsers.LogicalExpression, parsers.Constant, parsers.SelectItem:
		selectStmt.Filters = v
	}

	if distinctClause != nil {
		selectStmt.Distinct = true
	}

	if n, ok := count.(int); ok {
		selectStmt.Count = n
	}

	if offsetArr, ok := offsetClause.([]interface{}); ok && len(offsetArr) == 2 {
		if n, ok := offsetArr[0].(int); ok {
			selectStmt.Offset = n
		}

		if n, ok := offsetArr[1].(int); ok {
			selectStmt.Count = n
		}
	}

	if orderExpressions, ok := orderList.([]parsers.OrderExpression); ok {
		selectStmt.OrderExpressions = orderExpressions
	}

	if groupByClause != nil {
		selectStmt.GroupBy = groupByClause.([]parsers.SelectItem)
	}

	return selectStmt, nil
}

func makeJoin(table interface{}, column interface{}) (parsers.JoinItem, error) {
	joinItem := parsers.JoinItem{}

	if selectItem, isSelectItem := column.(parsers.SelectItem); isSelectItem {
		joinItem.SelectItem = selectItem
		joinItem.Table.Value = selectItem.Alias
	}

	if tableTyped, isTable := table.(parsers.Table); isTable {
		joinItem.Table = tableTyped
	}

	return joinItem, nil
}

func makeSelectItem(name interface{}, path interface{}, selectItemType parsers.SelectItemType) (parsers.SelectItem, error) {
	ps := path.([]interface{})

	paths := make([]string, 1)
	paths[0] = name.(string)
	for _, p := range ps {
		paths = append(paths, p.(string))
	}

	return parsers.SelectItem{Path: paths, Type: selectItemType}, nil
}

func makeColumnList(column interface{}, other_columns interface{}) ([]parsers.SelectItem, error) {
	collsAsArray := other_columns.([]interface{})
	columnList := make([]parsers.SelectItem, len(collsAsArray)+1)
	columnList[0] = column.(parsers.SelectItem)

	for i, v := range collsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			columnList[i+1] = col
		}
	}

	return columnList, nil
}

func makeSelectArray(columns interface{}) (parsers.SelectItem, error) {
	return parsers.SelectItem{
		SelectItems: columns.([]parsers.SelectItem),
		Type:        parsers.SelectItemTypeArray,
	}, nil
}

func makeSelectObject(field interface{}, other_fields interface{}) (parsers.SelectItem, error) {
	fieldsAsArray := other_fields.([]interface{})
	fieldsList := make([]parsers.SelectItem, len(fieldsAsArray)+1)
	fieldsList[0] = field.(parsers.SelectItem)

	for i, v := range fieldsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			fieldsList[i+1] = col
		}
	}

	return parsers.SelectItem{
		SelectItems: fieldsList,
		Type:        parsers.SelectItemTypeObject,
	}, nil
}

func makeOrderByClause(ex1 interface{}, others interface{}) ([]parsers.OrderExpression, error) {
	othersArray := others.([]interface{})
	orderList := make([]parsers.OrderExpression, len(othersArray)+1)
	orderList[0] = ex1.(parsers.OrderExpression)

	for i, v := range othersArray {
		if col, ok := v.(parsers.OrderExpression); ok {
			orderList[i+1] = col
		}
	}

	return orderList, nil
}

func makeOrderExpression(field interface{}, order interface{}) (parsers.OrderExpression, error) {
	value := parsers.OrderExpression{
		SelectItem: field.(parsers.SelectItem),
		Direction:  parsers.OrderDirectionAsc,
	}

	if orderValue, ok := order.(parsers.OrderDirection); ok {
		value.Direction = orderValue
	}

	return value, nil
}

func createFunctionCall(functionType parsers.FunctionCallType, arguments []interface{}) (parsers.FunctionCall, error) {
	return parsers.FunctionCall{Type: functionType, Arguments: arguments}, nil
}

func joinStrings(array []interface{}) string {
	var stringsArray []string
	for _, elem := range array {
		str, ok := elem.(string)
		if !ok {
			continue
		}
		stringsArray = append(stringsArray, str)
	}

	return strings.Join(stringsArray, "")
}

func combineExpressions(ex1 interface{}, exs interface{}, operation parsers.LogicalExpressionType) (interface{}, error) {
	if exs == nil || len(exs.([]interface{})) < 1 {
		return ex1, nil
	}

	return parsers.LogicalExpression{
		Expressions: append([]interface{}{ex1}, exs.([]interface{})...),
		Operation:   operation,
	}, nil
}

var g = &grammar{
	rules: []*rule{
		{
			name: "Input",
			pos:  position{line: 183, col: 1, offset: 4923},
			expr: &actionExpr{
				pos: position{line: 183, col: 10, offset: 4932},
				run: (*parser).callonInput1,
				expr: &labeledExpr{
					pos:   position{line: 183, col: 10, offset: 4932},
					label: "selectStmt",
					expr: &ruleRefExpr{
						pos:  position{line: 183, col: 21, offset: 4943},
						name: "SelectStmt",
					},
				},
			},
		},
		{
			name: "SelectStmt",
			pos:  position{line: 187, col: 1, offset: 4986},
			expr: &actionExpr{
				pos: position{line: 187, col: 15, offset: 5000},
				run: (*parser).callonSelectStmt1,
				expr: &seqExpr{
					pos: position{line: 187, col: 15, offset: 5000},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 187, col: 15, offset: 5000},
							name: "Select",
						},
						&ruleRefExpr{
							pos:  position{line: 187, col: 22, offset: 5007},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 188, col: 5, offset: 5014},
							label: "distinctClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 188, col: 20, offset: 5029},
								expr: &ruleRefExpr{
									pos:  position{line: 188, col: 20, offset: 5029},
									name: "DistinctClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 188, col: 36, offset: 5045},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 189, col: 5, offset: 5052},
							label: "topClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 189, col: 15, offset: 5062},
								expr: &ruleRefExpr{
									pos:  position{line: 189, col: 15, offset: 5062},
									name: "TopClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 189, col: 26, offset: 5073},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 190, col: 5, offset: 5080},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 190, col: 13, offset: 5088},
								name: "Selection",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 190, col: 23, offset: 5098},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 191, col: 5, offset: 5105},
							label: "fromClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 191, col: 16, offset: 5116},
								expr: &ruleRefExpr{
									pos:  position{line: 191, col: 16, offset: 5116},
									name: "FromClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 191, col: 28, offset: 5128},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 192, col: 5, offset: 5135},
							label: "joinClauses",
							expr: &zeroOrMoreExpr{
								pos: position{line: 192, col: 17, offset: 5147},
								expr: &actionExpr{
									pos: position{line: 192, col: 18, offset: 5148},
									run: (*parser).callonSelectStmt22,
									expr: &seqExpr{
										pos: position{line: 192, col: 18, offset: 5148},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 192, col: 18, offset: 5148},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 192, col: 21, offset: 5151},
												label: "join",
												expr: &ruleRefExpr{
													pos:  position{line: 192, col: 26, offset: 5156},
													name: "JoinClause",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 192, col: 60, offset: 5190},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 193, col: 5, offset: 5197},
							label: "whereClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 193, col: 17, offset: 5209},
								expr: &actionExpr{
									pos: position{line: 193, col: 18, offset: 5210},
									run: (*parser).callonSelectStmt30,
									expr: &seqExpr{
										pos: position{line: 193, col: 18, offset: 5210},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 193, col: 18, offset: 5210},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 193, col: 21, offset: 5213},
												name: "Where",
											},
											&ruleRefExpr{
												pos:  position{line: 193, col: 27, offset: 5219},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 193, col: 30, offset: 5222},
												label: "condition",
												expr: &ruleRefExpr{
													pos:  position{line: 193, col: 40, offset: 5232},
													name: "Condition",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 194, col: 5, offset: 5274},
							label: "groupByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 194, col: 19, offset: 5288},
								expr: &actionExpr{
									pos: position{line: 194, col: 20, offset: 5289},
									run: (*parser).callonSelectStmt39,
									expr: &seqExpr{
										pos: position{line: 194, col: 20, offset: 5289},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 194, col: 20, offset: 5289},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 194, col: 23, offset: 5292},
												name: "GroupBy",
											},
											&ruleRefExpr{
												pos:  position{line: 194, col: 31, offset: 5300},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 194, col: 34, offset: 5303},
												label: "columns",
												expr: &ruleRefExpr{
													pos:  position{line: 194, col: 42, offset: 5311},
													name: "ColumnList",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 195, col: 5, offset: 5352},
							label: "orderByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 195, col: 19, offset: 5366},
								expr: &actionExpr{
									pos: position{line: 195, col: 20, offset: 5367},
									run: (*parser).callonSelectStmt48,
									expr: &seqExpr{
										pos: position{line: 195, col: 20, offset: 5367},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 195, col: 20, offset: 5367},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 195, col: 23, offset: 5370},
												label: "order",
												expr: &ruleRefExpr{
													pos:  position{line: 195, col: 29, offset: 5376},
													name: "OrderByClause",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 196, col: 5, offset: 5418},
							label: "offsetClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 196, col: 18, offset: 5431},
								expr: &actionExpr{
									pos: position{line: 196, col: 19, offset: 5432},
									run: (*parser).callonSelectStmt55,
									expr: &seqExpr{
										pos: position{line: 196, col: 19, offset: 5432},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 196, col: 19, offset: 5432},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 196, col: 22, offset: 5435},
												label: "offset",
												expr: &ruleRefExpr{
													pos:  position{line: 196, col: 29, offset: 5442},
													name: "OffsetClause",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "DistinctClause",
			pos:  position{line: 201, col: 1, offset: 5637},
			expr: &litMatcher{
				pos:        position{line: 201, col: 19, offset: 5655},
				val:        "distinct",
				ignoreCase: true,
				want:       "\"DISTINCT\"i",
			},
		},
		{
			name: "TopClause",
			pos:  position{line: 203, col: 1, offset: 5668},
			expr: &actionExpr{
				pos: position{line: 203, col: 14, offset: 5681},
				run: (*parser).callonTopClause1,
				expr: &seqExpr{
					pos: position{line: 203, col: 14, offset: 5681},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 203, col: 14, offset: 5681},
							name: "Top",
						},
						&ruleRefExpr{
							pos:  position{line: 203, col: 18, offset: 5685},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 203, col: 21, offset: 5688},
							label: "count",
							expr: &ruleRefExpr{
								pos:  position{line: 203, col: 27, offset: 5694},
								name: "Integer",
							},
						},
					},
				},
			},
		},
		{
			name: "FromClause",
			pos:  position{line: 207, col: 1, offset: 5729},
			expr: &choiceExpr{
				pos: position{line: 207, col: 15, offset: 5743},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 207, col: 15, offset: 5743},
						run: (*parser).callonFromClause2,
						expr: &seqExpr{
							pos: position{line: 207, col: 15, offset: 5743},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 207, col: 15, offset: 5743},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 207, col: 20, offset: 5748},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 207, col: 23, offset: 5751},
									label: "table",
									expr: &ruleRefExpr{
										pos:  position{line: 207, col: 29, offset: 5757},
										name: "TableName",
									},
								},
								&labeledExpr{
									pos:   position{line: 207, col: 39, offset: 5767},
									label: "selectItem",
									expr: &actionExpr{
										pos: position{line: 207, col: 51, offset: 5779},
										run: (*parser).callonFromClause9,
										expr: &seqExpr{
											pos: position{line: 207, col: 51, offset: 5779},
											exprs: []any{
												&ruleRefExpr{
													pos:  position{line: 207, col: 51, offset: 5779},
													name: "ws",
												},
												&ruleRefExpr{
													pos:  position{line: 207, col: 54, offset: 5782},
													name: "In",
												},
												&ruleRefExpr{
													pos:  position{line: 207, col: 57, offset: 5785},
													name: "ws",
												},
												&labeledExpr{
													pos:   position{line: 207, col: 60, offset: 5788},
													label: "column",
													expr: &ruleRefExpr{
														pos:  position{line: 207, col: 67, offset: 5795},
														name: "SelectItemWithAlias",
													},
												},
											},
										},
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 216, col: 5, offset: 6039},
						run: (*parser).callonFromClause16,
						expr: &seqExpr{
							pos: position{line: 216, col: 5, offset: 6039},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 216, col: 5, offset: 6039},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 216, col: 10, offset: 6044},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 216, col: 13, offset: 6047},
									label: "column",
									expr: &ruleRefExpr{
										pos:  position{line: 216, col: 20, offset: 6054},
										name: "SelectItemWithAlias",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 223, col: 5, offset: 6262},
						run: (*parser).callonFromClause22,
						expr: &seqExpr{
							pos: position{line: 223, col: 5, offset: 6262},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 223, col: 5, offset: 6262},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 223, col: 10, offset: 6267},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 223, col: 13, offset: 6270},
									label: "subQuery",
									expr: &ruleRefExpr{
										pos:  position{line: 223, col: 22, offset: 6279},
										name: "SubQuerySelectItem",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SubQuery",
			pos:  position{line: 232, col: 1, offset: 6460},
			expr: &actionExpr{
				pos: position{line: 232, col: 13, offset: 6472},
				run: (*parser).callonSubQuery1,
				expr: &seqExpr{
					pos: position{line: 232, col: 13, offset: 6472},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 232, col: 13, offset: 6472},
							label: "exists",
							expr: &zeroOrOneExpr{
								pos: position{line: 232, col: 20, offset: 6479},
								expr: &actionExpr{
									pos: position{line: 232, col: 21, offset: 6480},
									run: (*parser).callonSubQuery5,
									expr: &seqExpr{
										pos: position{line: 232, col: 21, offset: 6480},
										exprs: []any{
											&labeledExpr{
												pos:   position{line: 232, col: 21, offset: 6480},
												label: "exists",
												expr: &ruleRefExpr{
													pos:  position{line: 232, col: 28, offset: 6487},
													name: "Exists",
												},
											},
											&ruleRefExpr{
												pos:  position{line: 232, col: 35, offset: 6494},
												name: "ws",
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 232, col: 63, offset: 6522},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 232, col: 67, offset: 6526},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 232, col: 70, offset: 6529},
							label: "selectStmt",
							expr: &ruleRefExpr{
								pos:  position{line: 232, col: 81, offset: 6540},
								name: "SelectStmt",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 232, col: 92, offset: 6551},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 232, col: 95, offset: 6554},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubQuerySelectItem",
			pos:  position{line: 241, col: 1, offset: 6766},
			expr: &actionExpr{
				pos: position{line: 241, col: 23, offset: 6788},
				run: (*parser).callonSubQuerySelectItem1,
				expr: &seqExpr{
					pos: position{line: 241, col: 23, offset: 6788},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 241, col: 23, offset: 6788},
							label: "subQuery",
							expr: &ruleRefExpr{
								pos:  position{line: 241, col: 32, offset: 6797},
								name: "SubQuery",
							},
						},
						&labeledExpr{
							pos:   position{line: 241, col: 41, offset: 6806},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 241, col: 50, offset: 6815},
								expr: &actionExpr{
									pos: position{line: 241, col: 51, offset: 6816},
									run: (*parser).callonSubQuerySelectItem7,
									expr: &seqExpr{
										pos: position{line: 241, col: 51, offset: 6816},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 241, col: 51, offset: 6816},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 241, col: 54, offset: 6819},
												label: "alias",
												expr: &ruleRefExpr{
													pos:  position{line: 241, col: 60, offset: 6825},
													name: "AsClause",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "JoinClause",
			pos:  position{line: 254, col: 1, offset: 7110},
			expr: &choiceExpr{
				pos: position{line: 254, col: 15, offset: 7124},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 254, col: 15, offset: 7124},
						run: (*parser).callonJoinClause2,
						expr: &seqExpr{
							pos: position{line: 254, col: 15, offset: 7124},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 254, col: 15, offset: 7124},
									name: "Join",
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 20, offset: 7129},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 254, col: 23, offset: 7132},
									label: "table",
									expr: &ruleRefExpr{
										pos:  position{line: 254, col: 29, offset: 7138},
										name: "TableName",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 39, offset: 7148},
									name: "ws",
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 42, offset: 7151},
									name: "In",
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 45, offset: 7154},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 254, col: 48, offset: 7157},
									label: "column",
									expr: &ruleRefExpr{
										pos:  position{line: 254, col: 55, offset: 7164},
										name: "SelectItemWithAlias",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 256, col: 5, offset: 7225},
						run: (*parser).callonJoinClause13,
						expr: &seqExpr{
							pos: position{line: 256, col: 5, offset: 7225},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 256, col: 5, offset: 7225},
									name: "Join",
								},
								&ruleRefExpr{
									pos:  position{line: 256, col: 10, offset: 7230},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 256, col: 13, offset: 7233},
									label: "subQuery",
									expr: &ruleRefExpr{
										pos:  position{line: 256, col: 22, offset: 7242},
										name: "SubQuerySelectItem",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OffsetClause",
			pos:  position{line: 260, col: 1, offset: 7301},
			expr: &actionExpr{
				pos: position{line: 260, col: 17, offset: 7317},
				run: (*parser).callonOffsetClause1,
				expr: &seqExpr{
					pos: position{line: 260, col: 17, offset: 7317},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 260, col: 17, offset: 7317},
							name: "Offset",
						},
						&ruleRefExpr{
							pos:  position{line: 260, col: 24, offset: 7324},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 260, col: 27, offset: 7327},
							label: "offset",
							expr: &ruleRefExpr{
								pos:  position{line: 260, col: 34, offset: 7334},
								name: "IntegerLiteral",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 260, col: 49, offset: 7349},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 260, col: 52, offset: 7352},
							val:        "limit",
							ignoreCase: true,
							want:       "\"LIMIT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 260, col: 61, offset: 7361},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 260, col: 64, offset: 7364},
							label: "limit",
							expr: &ruleRefExpr{
								pos:  position{line: 260, col: 70, offset: 7370},
								name: "IntegerLiteral",
							},
						},
					},
				},
			},
		},
		{
			name: "Selection",
			pos:  position{line: 264, col: 1, offset: 7485},
			expr: &choiceExpr{
				pos: position{line: 264, col: 14, offset: 7498},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 264, col: 14, offset: 7498},
						name: "SelectValueSpec",
					},
					&ruleRefExpr{
						pos:  position{line: 264, col: 32, offset: 7516},
						name: "ColumnList",
					},
					&ruleRefExpr{
						pos:  position{line: 264, col: 45, offset: 7529},
						name: "SelectAsterisk",
					},
				},
			},
		},
		{
			name: "SelectAsterisk",
			pos:  position{line: 266, col: 1, offset: 7545},
			expr: &actionExpr{
				pos: position{line: 266, col: 19, offset: 7563},
				run: (*parser).callonSelectAsterisk1,
				expr: &litMatcher{
					pos:        position{line: 266, col: 19, offset: 7563},
					val:        "*",
					ignoreCase: false,
					want:       "\"*\"",
				},
			},
		},
		{
			name: "ColumnList",
			pos:  position{line: 272, col: 1, offset: 7758},
			expr: &actionExpr{
				pos: position{line: 272, col: 15, offset: 7772},
				run: (*parser).callonColumnList1,
				expr: &seqExpr{
					pos: position{line: 272, col: 15, offset: 7772},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 272, col: 15, offset: 7772},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 272, col: 22, offset: 7779},
								name: "ExpressionOrSelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 272, col: 45, offset: 7802},
							label: "other_columns",
							expr: &zeroOrMoreExpr{
								pos: position{line: 272, col: 59, offset: 7816},
								expr: &actionExpr{
									pos: position{line: 272, col: 60, offset: 7817},
									run: (*parser).callonColumnList7,
									expr: &seqExpr{
										pos: position{line: 272, col: 60, offset: 7817},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 272, col: 60, offset: 7817},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 272, col: 63, offset: 7820},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 272, col: 67, offset: 7824},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 272, col: 70, offset: 7827},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 272, col: 75, offset: 7832},
													name: "ExpressionOrSelectItem",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ExpressionOrSelectItem",
			pos:  position{line: 276, col: 1, offset: 7931},
			expr: &choiceExpr{
				pos: position{line: 276, col: 27, offset: 7957},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 276, col: 27, offset: 7957},
						run: (*parser).callonExpressionOrSelectItem2,
						expr: &seqExpr{
							pos: position{line: 276, col: 27, offset: 7957},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 276, col: 27, offset: 7957},
									label: "expression",
									expr: &ruleRefExpr{
										pos:  position{line: 276, col: 38, offset: 7968},
										name: "OrExpression",
									},
								},
								&labeledExpr{
									pos:   position{line: 276, col: 51, offset: 7981},
									label: "asClause",
									expr: &zeroOrOneExpr{
										pos: position{line: 276, col: 60, offset: 7990},
										expr: &ruleRefExpr{
											pos:  position{line: 276, col: 60, offset: 7990},
											name: "AsClause",
										},
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 297, col: 5, offset: 8605},
						run: (*parser).callonExpressionOrSelectItem9,
						expr: &labeledExpr{
							pos:   position{line: 297, col: 5, offset: 8605},
							label: "item",
							expr: &ruleRefExpr{
								pos:  position{line: 297, col: 10, offset: 8610},
								name: "SelectItemWithAlias",
							},
						},
					},
				},
			},
		},
		{
			name: "SelectValueSpec",
			pos:  position{line: 299, col: 1, offset: 8652},
			expr: &actionExpr{
				pos: position{line: 299, col: 20, offset: 8671},
				run: (*parser).callonSelectValueSpec1,
				expr: &seqExpr{
					pos: position{line: 299, col: 20, offset: 8671},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 299, col: 20, offset: 8671},
							val:        "value",
							ignoreCase: true,
							want:       "\"VALUE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 299, col: 29, offset: 8680},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 299, col: 32, offset: 8683},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 299, col: 39, offset: 8690},
								name: "SelectItemWithAlias",
							},
						},
					},
				},
			},
		},
		{
			name: "TableName",
			pos:  position{line: 305, col: 1, offset: 8853},
			expr: &actionExpr{
				pos: position{line: 305, col: 14, offset: 8866},
				run: (*parser).callonTableName1,
				expr: &labeledExpr{
					pos:   position{line: 305, col: 14, offset: 8866},
					label: "key",
					expr: &ruleRefExpr{
						pos:  position{line: 305, col: 18, offset: 8870},
						name: "Identifier",
					},
				},
			},
		},
		{
			name: "SelectArray",
			pos:  position{line: 309, col: 1, offset: 8937},
			expr: &actionExpr{
				pos: position{line: 309, col: 16, offset: 8952},
				run: (*parser).callonSelectArray1,
				expr: &seqExpr{
					pos: position{line: 309, col: 16, offset: 8952},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 309, col: 16, offset: 8952},
							val:        "[",
							ignoreCase: false,
							want:       "\"[\"",
						},
						&ruleRefExpr{
							pos:  position{line: 309, col: 20, offset: 8956},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 309, col: 23, offset: 8959},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 309, col: 31, offset: 8967},
								name: "ColumnList",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 309, col: 42, offset: 8978},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 309, col: 45, offset: 8981},
							val:        "]",
							ignoreCase: false,
							want:       "\"]\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObject",
			pos:  position{line: 313, col: 1, offset: 9026},
			expr: &choiceExpr{
				pos: position{line: 313, col: 17, offset: 9042},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 313, col: 17, offset: 9042},
						run: (*parser).callonSelectObject2,
						expr: &seqExpr{
							pos: position{line: 313, col: 17, offset: 9042},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 313, col: 17, offset: 9042},
									val:        "{",
									ignoreCase: false,
									want:       "\"{\"",
								},
								&ruleRefExpr{
									pos:  position{line: 313, col: 21, offset: 9046},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 313, col: 24, offset: 9049},
									label: "field",
									expr: &ruleRefExpr{
										pos:  position{line: 313, col: 30, offset: 9055},
										name: "SelectObjectField",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 313, col: 48, offset: 9073},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 313, col: 51, offset: 9076},
									label: "other_fields",
									expr: &zeroOrMoreExpr{
										pos: position{line: 313, col: 64, offset: 9089},
										expr: &actionExpr{
											pos: position{line: 313, col: 65, offset: 9090},
											run: (*parser).callonSelectObject11,
											expr: &seqExpr{
												pos: position{line: 313, col: 65, offset: 9090},
												exprs: []any{
													&ruleRefExpr{
														pos:  position{line: 313, col: 65, offset: 9090},
														name: "ws",
													},
													&litMatcher{
														pos:        position{line: 313, col: 68, offset: 9093},
														val:        ",",
														ignoreCase: false,
														want:       "\",\"",
													},
													&ruleRefExpr{
														pos:  position{line: 313, col: 72, offset: 9097},
														name: "ws",
													},
													&labeledExpr{
														pos:   position{line: 313, col: 75, offset: 9100},
														label: "coll",
														expr: &ruleRefExpr{
															pos:  position{line: 313, col: 80, offset: 9105},
															name: "SelectObjectField",
														},
													},
												},
											},
										},
									},
								},
								&ruleRefExpr{
									pos:  position{line: 313, col: 120, offset: 9145},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 313, col: 123, offset: 9148},
									val:        "}",
									ignoreCase: false,
									want:       "\"}\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 315, col: 5, offset: 9207},
						run: (*parser).callonSelectObject20,
						expr: &seqExpr{
							pos: position{line: 315, col: 5, offset: 9207},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 315, col: 5, offset: 9207},
									val:        "{",
									ignoreCase: false,
									want:       "\"{\"",
								},
								&ruleRefExpr{
									pos:  position{line: 315, col: 9, offset: 9211},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 315, col: 12, offset: 9214},
									val:        "}",
									ignoreCase: false,
									want:       "\"}\"",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectObjectField",
			pos:  position{line: 322, col: 1, offset: 9346},
			expr: &actionExpr{
				pos: position{line: 322, col: 22, offset: 9367},
				run: (*parser).callonSelectObjectField1,
				expr: &seqExpr{
					pos: position{line: 322, col: 22, offset: 9367},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 322, col: 22, offset: 9367},
							label: "name",
							expr: &choiceExpr{
								pos: position{line: 322, col: 28, offset: 9373},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 322, col: 28, offset: 9373},
										name: "Identifier",
									},
									&actionExpr{
										pos: position{line: 322, col: 41, offset: 9386},
										run: (*parser).callonSelectObjectField6,
										expr: &seqExpr{
											pos: position{line: 322, col: 41, offset: 9386},
											exprs: []any{
												&litMatcher{
													pos:        position{line: 322, col: 41, offset: 9386},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
												&labeledExpr{
													pos:   position{line: 322, col: 46, offset: 9391},
													label: "key",
													expr: &ruleRefExpr{
														pos:  position{line: 322, col: 50, offset: 9395},
														name: "Identifier",
													},
												},
												&litMatcher{
													pos:        position{line: 322, col: 61, offset: 9406},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 322, col: 87, offset: 9432},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 322, col: 90, offset: 9435},
							val:        ":",
							ignoreCase: false,
							want:       "\":\"",
						},
						&ruleRefExpr{
							pos:  position{line: 322, col: 94, offset: 9439},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 322, col: 97, offset: 9442},
							label: "selectItem",
							expr: &ruleRefExpr{
								pos:  position{line: 322, col: 108, offset: 9453},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "SelectProperty",
			pos:  position{line: 328, col: 1, offset: 9559},
			expr: &actionExpr{
				pos: position{line: 328, col: 19, offset: 9577},
				run: (*parser).callonSelectProperty1,
				expr: &seqExpr{
					pos: position{line: 328, col: 19, offset: 9577},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 328, col: 19, offset: 9577},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 328, col: 24, offset: 9582},
								name: "Identifier",
							},
						},
						&labeledExpr{
							pos:   position{line: 328, col: 35, offset: 9593},
							label: "path",
							expr: &zeroOrMoreExpr{
								pos: position{line: 328, col: 40, offset: 9598},
								expr: &choiceExpr{
									pos: position{line: 328, col: 41, offset: 9599},
									alternatives: []any{
										&ruleRefExpr{
											pos:  position{line: 328, col: 41, offset: 9599},
											name: "DotFieldAccess",
										},
										&ruleRefExpr{
											pos:  position{line: 328, col: 58, offset: 9616},
											name: "ArrayFieldAccess",
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectItemWithAlias",
			pos:  position{line: 332, col: 1, offset: 9707},
			expr: &actionExpr{
				pos: position{line: 332, col: 24, offset: 9730},
				run: (*parser).callonSelectItemWithAlias1,
				expr: &seqExpr{
					pos: position{line: 332, col: 24, offset: 9730},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 332, col: 24, offset: 9730},
							label: "selectItem",
							expr: &ruleRefExpr{
								pos:  position{line: 332, col: 35, offset: 9741},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 332, col: 46, offset: 9752},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 332, col: 55, offset: 9761},
								expr: &ruleRefExpr{
									pos:  position{line: 332, col: 55, offset: 9761},
									name: "AsClause",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectItem",
			pos:  position{line: 340, col: 1, offset: 9928},
			expr: &actionExpr{
				pos: position{line: 340, col: 15, offset: 9942},
				run: (*parser).callonSelectItem1,
				expr: &labeledExpr{
					pos:   position{line: 340, col: 15, offset: 9942},
					label: "selectItem",
					expr: &choiceExpr{
						pos: position{line: 340, col: 27, offset: 9954},
						alternatives: []any{
							&ruleRefExpr{
								pos:  position{line: 340, col: 27, offset: 9954},
								name: "SubQuerySelectItem",
							},
							&ruleRefExpr{
								pos:  position{line: 340, col: 48, offset: 9975},
								name: "Literal",
							},
							&ruleRefExpr{
								pos:  position{line: 340, col: 58, offset: 9985},
								name: "FunctionCall",
							},
							&ruleRefExpr{
								pos:  position{line: 340, col: 73, offset: 10000},
								name: "SelectArray",
							},
							&ruleRefExpr{
								pos:  position{line: 340, col: 87, offset: 10014},
								name: "SelectObject",
							},
							&ruleRefExpr{
								pos:  position{line: 340, col: 102, offset: 10029},
								name: "SelectProperty",
							},
						},
					},
				},
			},
		},
		{
			name: "AsClause",
			pos:  position{line: 360, col: 1, offset: 10551},
			expr: &actionExpr{
				pos: position{line: 360, col: 13, offset: 10563},
				run: (*parser).callonAsClause1,
				expr: &seqExpr{
					pos: position{line: 360, col: 13, offset: 10563},
					exprs: []any{
						&zeroOrOneExpr{
							pos: position{line: 360, col: 13, offset: 10563},
							expr: &seqExpr{
								pos: position{line: 360, col: 14, offset: 10564},
								exprs: []any{
									&ruleRefExpr{
										pos:  position{line: 360, col: 14, offset: 10564},
										name: "ws",
									},
									&ruleRefExpr{
										pos:  position{line: 360, col: 17, offset: 10567},
										name: "As",
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 360, col: 22, offset: 10572},
							name: "ws",
						},
						&notExpr{
							pos: position{line: 360, col: 25, offset: 10575},
							expr: &ruleRefExpr{
								pos:  position{line: 360, col: 26, offset: 10576},
								name: "ExcludedKeywords",
							},
						},
						&labeledExpr{
							pos:   position{line: 360, col: 43, offset: 10593},
							label: "alias",
							expr: &ruleRefExpr{
								pos:  position{line: 360, col: 49, offset: 10599},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ExcludedKeywords",
			pos:  position{line: 364, col: 1, offset: 10637},
			expr: &choiceExpr{
				pos: position{line: 364, col: 21, offset: 10657},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 364, col: 21, offset: 10657},
						name: "Select",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 30, offset: 10666},
						name: "Top",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 36, offset: 10672},
						name: "As",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 41, offset: 10677},
						name: "From",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 48, offset: 10684},
						name: "In",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 53, offset: 10689},
						name: "Join",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 60, offset: 10696},
						name: "Exists",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 69, offset: 10705},
						name: "Where",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 77, offset: 10713},
						name: "And",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 83, offset: 10719},
						name: "Or",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 88, offset: 10724},
						name: "Not",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 94, offset: 10730},
						name: "GroupBy",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 104, offset: 10740},
						name: "OrderBy",
					},
					&ruleRefExpr{
						pos:  position{line: 364, col: 114, offset: 10750},
						name: "Offset",
					},
				},
			},
		},
		{
			name: "DotFieldAccess",
			pos:  position{line: 366, col: 1, offset: 10758},
			expr: &actionExpr{
				pos: position{line: 366, col: 19, offset: 10776},
				run: (*parser).callonDotFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 366, col: 19, offset: 10776},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 366, col: 19, offset: 10776},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&labeledExpr{
							pos:   position{line: 366, col: 23, offset: 10780},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 366, col: 26, offset: 10783},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ArrayFieldAccess",
			pos:  position{line: 370, col: 1, offset: 10818},
			expr: &choiceExpr{
				pos: position{line: 370, col: 21, offset: 10838},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 370, col: 21, offset: 10838},
						run: (*parser).callonArrayFieldAccess2,
						expr: &seqExpr{
							pos: position{line: 370, col: 21, offset: 10838},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 370, col: 21, offset: 10838},
									val:        "[\"",
									ignoreCase: false,
									want:       "\"[\\\"\"",
								},
								&labeledExpr{
									pos:   position{line: 370, col: 27, offset: 10844},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 370, col: 30, offset: 10847},
										name: "Identifier",
									},
								},
								&litMatcher{
									pos:        position{line: 370, col: 41, offset: 10858},
									val:        "\"]",
									ignoreCase: false,
									want:       "\"\\\"]\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 371, col: 5, offset: 10887},
						run: (*parser).callonArrayFieldAccess8,
						expr: &seqExpr{
							pos: position{line: 371, col: 5, offset: 10887},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 371, col: 5, offset: 10887},
									val:        "[",
									ignoreCase: false,
									want:       "\"[\"",
								},
								&labeledExpr{
									pos:   position{line: 371, col: 9, offset: 10891},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 371, col: 12, offset: 10894},
										name: "Integer",
									},
								},
								&litMatcher{
									pos:        position{line: 371, col: 20, offset: 10902},
									val:        "]",
									ignoreCase: false,
									want:       "\"]\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 372, col: 5, offset: 10949},
						run: (*parser).callonArrayFieldAccess14,
						expr: &seqExpr{
							pos: position{line: 372, col: 5, offset: 10949},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 372, col: 5, offset: 10949},
									val:        "[",
									ignoreCase: false,
									want:       "\"[\"",
								},
								&labeledExpr{
									pos:   position{line: 372, col: 9, offset: 10953},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 372, col: 12, offset: 10956},
										name: "ParameterConstant",
									},
								},
								&litMatcher{
									pos:        position{line: 372, col: 30, offset: 10974},
									val:        "]",
									ignoreCase: false,
									want:       "\"]\"",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "Identifier",
			pos:  position{line: 374, col: 1, offset: 11032},
			expr: &actionExpr{
				pos: position{line: 374, col: 15, offset: 11046},
				run: (*parser).callonIdentifier1,
				expr: &seqExpr{
					pos: position{line: 374, col: 15, offset: 11046},
					exprs: []any{
						&charClassMatcher{
							pos:        position{line: 374, col: 15, offset: 11046},
							val:        "[a-zA-Z_]",
							chars:      []rune{'_'},
							ranges:     []rune{'a', 'z', 'A', 'Z'},
							ignoreCase: false,
							inverted:   false,
						},
						&zeroOrMoreExpr{
							pos: position{line: 374, col: 24, offset: 11055},
							expr: &charClassMatcher{
								pos:        position{line: 374, col: 24, offset: 11055},
								val:        "[a-zA-Z0-9_]",
								chars:      []rune{'_'},
								ranges:     []rune{'a', 'z', 'A', 'Z', '0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "Condition",
			pos:  position{line: 378, col: 1, offset: 11105},
			expr: &actionExpr{
				pos: position{line: 378, col: 14, offset: 11118},
				run: (*parser).callonCondition1,
				expr: &labeledExpr{
					pos:   position{line: 378, col: 14, offset: 11118},
					label: "expression",
					expr: &ruleRefExpr{
						pos:  position{line: 378, col: 25, offset: 11129},
						name: "OrExpression",
					},
				},
			},
		},
		{
			name: "OrExpression",
			pos:  position{line: 382, col: 1, offset: 11174},
			expr: &actionExpr{
				pos: position{line: 382, col: 17, offset: 11190},
				run: (*parser).callonOrExpression1,
				expr: &seqExpr{
					pos: position{line: 382, col: 17, offset: 11190},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 382, col: 17, offset: 11190},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 382, col: 21, offset: 11194},
								name: "AndExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 382, col: 35, offset: 11208},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 382, col: 39, offset: 11212},
								expr: &actionExpr{
									pos: position{line: 382, col: 40, offset: 11213},
									run: (*parser).callonOrExpression7,
									expr: &seqExpr{
										pos: position{line: 382, col: 40, offset: 11213},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 382, col: 40, offset: 11213},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 382, col: 43, offset: 11216},
												name: "Or",
											},
											&ruleRefExpr{
												pos:  position{line: 382, col: 46, offset: 11219},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 382, col: 49, offset: 11222},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 382, col: 52, offset: 11225},
													name: "AndExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AndExpression",
			pos:  position{line: 386, col: 1, offset: 11338},
			expr: &actionExpr{
				pos: position{line: 386, col: 18, offset: 11355},
				run: (*parser).callonAndExpression1,
				expr: &seqExpr{
					pos: position{line: 386, col: 18, offset: 11355},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 386, col: 18, offset: 11355},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 386, col: 22, offset: 11359},
								name: "ComparisonExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 386, col: 43, offset: 11380},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 386, col: 47, offset: 11384},
								expr: &actionExpr{
									pos: position{line: 386, col: 48, offset: 11385},
									run: (*parser).callonAndExpression7,
									expr: &seqExpr{
										pos: position{line: 386, col: 48, offset: 11385},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 386, col: 48, offset: 11385},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 386, col: 51, offset: 11388},
												name: "And",
											},
											&ruleRefExpr{
												pos:  position{line: 386, col: 55, offset: 11392},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 386, col: 58, offset: 11395},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 386, col: 61, offset: 11398},
													name: "ComparisonExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ComparisonExpression",
			pos:  position{line: 390, col: 1, offset: 11519},
			expr: &choiceExpr{
				pos: position{line: 390, col: 25, offset: 11543},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 390, col: 25, offset: 11543},
						run: (*parser).callonComparisonExpression2,
						expr: &seqExpr{
							pos: position{line: 390, col: 25, offset: 11543},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 390, col: 25, offset: 11543},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 390, col: 29, offset: 11547},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 390, col: 32, offset: 11550},
									label: "ex",
									expr: &ruleRefExpr{
										pos:  position{line: 390, col: 35, offset: 11553},
										name: "OrExpression",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 390, col: 48, offset: 11566},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 390, col: 51, offset: 11569},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 391, col: 7, offset: 11598},
						run: (*parser).callonComparisonExpression10,
						expr: &seqExpr{
							pos: position{line: 391, col: 7, offset: 11598},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 391, col: 7, offset: 11598},
									label: "left",
									expr: &ruleRefExpr{
										pos:  position{line: 391, col: 12, offset: 11603},
										name: "SelectItem",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 391, col: 23, offset: 11614},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 391, col: 26, offset: 11617},
									label: "op",
									expr: &ruleRefExpr{
										pos:  position{line: 391, col: 29, offset: 11620},
										name: "ComparisonOperator",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 391, col: 48, offset: 11639},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 391, col: 51, offset: 11642},
									label: "right",
									expr: &ruleRefExpr{
										pos:  position{line: 391, col: 57, offset: 11648},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 393, col: 5, offset: 11755},
						run: (*parser).callonComparisonExpression20,
						expr: &seqExpr{
							pos: position{line: 393, col: 5, offset: 11755},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 393, col: 5, offset: 11755},
									label: "inv",
									expr: &zeroOrOneExpr{
										pos: position{line: 393, col: 9, offset: 11759},
										expr: &seqExpr{
											pos: position{line: 393, col: 10, offset: 11760},
											exprs: []any{
												&ruleRefExpr{
													pos:  position{line: 393, col: 10, offset: 11760},
													name: "Not",
												},
												&ruleRefExpr{
													pos:  position{line: 393, col: 14, offset: 11764},
													name: "ws",
												},
											},
										},
									},
								},
								&labeledExpr{
									pos:   position{line: 393, col: 19, offset: 11769},
									label: "ex",
									expr: &ruleRefExpr{
										pos:  position{line: 393, col: 22, offset: 11772},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 400, col: 5, offset: 11902},
						run: (*parser).callonComparisonExpression29,
						expr: &labeledExpr{
							pos:   position{line: 400, col: 5, offset: 11902},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 400, col: 8, offset: 11905},
								name: "BooleanLiteral",
							},
						},
					},
				},
			},
		},
		{
			name: "OrderByClause",
			pos:  position{line: 402, col: 1, offset: 11940},
			expr: &actionExpr{
				pos: position{line: 402, col: 18, offset: 11957},
				run: (*parser).callonOrderByClause1,
				expr: &seqExpr{
					pos: position{line: 402, col: 18, offset: 11957},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 402, col: 18, offset: 11957},
							name: "OrderBy",
						},
						&ruleRefExpr{
							pos:  position{line: 402, col: 26, offset: 11965},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 402, col: 29, offset: 11968},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 402, col: 33, offset: 11972},
								name: "OrderExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 402, col: 49, offset: 11988},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 402, col: 56, offset: 11995},
								expr: &actionExpr{
									pos: position{line: 402, col: 57, offset: 11996},
									run: (*parser).callonOrderByClause9,
									expr: &seqExpr{
										pos: position{line: 402, col: 57, offset: 11996},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 402, col: 57, offset: 11996},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 402, col: 60, offset: 11999},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 402, col: 64, offset: 12003},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 402, col: 67, offset: 12006},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 402, col: 70, offset: 12009},
													name: "OrderExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderExpression",
			pos:  position{line: 406, col: 1, offset: 12093},
			expr: &actionExpr{
				pos: position{line: 406, col: 20, offset: 12112},
				run: (*parser).callonOrderExpression1,
				expr: &seqExpr{
					pos: position{line: 406, col: 20, offset: 12112},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 406, col: 20, offset: 12112},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 406, col: 26, offset: 12118},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 406, col: 41, offset: 12133},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 406, col: 44, offset: 12136},
							label: "order",
							expr: &zeroOrOneExpr{
								pos: position{line: 406, col: 50, offset: 12142},
								expr: &ruleRefExpr{
									pos:  position{line: 406, col: 50, offset: 12142},
									name: "OrderDirection",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderDirection",
			pos:  position{line: 410, col: 1, offset: 12208},
			expr: &actionExpr{
				pos: position{line: 410, col: 19, offset: 12226},
				run: (*parser).callonOrderDirection1,
				expr: &choiceExpr{
					pos: position{line: 410, col: 20, offset: 12227},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 410, col: 20, offset: 12227},
							val:        "asc",
							ignoreCase: true,
							want:       "\"ASC\"i",
						},
						&litMatcher{
							pos:        position{line: 410, col: 29, offset: 12236},
							val:        "desc",
							ignoreCase: true,
							want:       "\"DESC\"i",
						},
					},
				},
			},
		},
		{
			name: "Select",
			pos:  position{line: 418, col: 1, offset: 12388},
			expr: &litMatcher{
				pos:        position{line: 418, col: 11, offset: 12398},
				val:        "select",
				ignoreCase: true,
				want:       "\"SELECT\"i",
			},
		},
		{
			name: "Top",
			pos:  position{line: 420, col: 1, offset: 12409},
			expr: &litMatcher{
				pos:        position{line: 420, col: 8, offset: 12416},
				val:        "top",
				ignoreCase: true,
				want:       "\"TOP\"i",
			},
		},
		{
			name: "As",
			pos:  position{line: 422, col: 1, offset: 12424},
			expr: &litMatcher{
				pos:        position{line: 422, col: 7, offset: 12430},
				val:        "as",
				ignoreCase: true,
				want:       "\"AS\"i",
			},
		},
		{
			name: "From",
			pos:  position{line: 424, col: 1, offset: 12437},
			expr: &litMatcher{
				pos:        position{line: 424, col: 9, offset: 12445},
				val:        "from",
				ignoreCase: true,
				want:       "\"FROM\"i",
			},
		},
		{
			name: "In",
			pos:  position{line: 426, col: 1, offset: 12454},
			expr: &litMatcher{
				pos:        position{line: 426, col: 7, offset: 12460},
				val:        "in",
				ignoreCase: true,
				want:       "\"IN\"i",
			},
		},
		{
			name: "Join",
			pos:  position{line: 428, col: 1, offset: 12467},
			expr: &litMatcher{
				pos:        position{line: 428, col: 9, offset: 12475},
				val:        "join",
				ignoreCase: true,
				want:       "\"JOIN\"i",
			},
		},
		{
			name: "Exists",
			pos:  position{line: 430, col: 1, offset: 12484},
			expr: &litMatcher{
				pos:        position{line: 430, col: 11, offset: 12494},
				val:        "exists",
				ignoreCase: true,
				want:       "\"EXISTS\"i",
			},
		},
		{
			name: "Where",
			pos:  position{line: 432, col: 1, offset: 12505},
			expr: &litMatcher{
				pos:        position{line: 432, col: 10, offset: 12514},
				val:        "where",
				ignoreCase: true,
				want:       "\"WHERE\"i",
			},
		},
		{
			name: "And",
			pos:  position{line: 434, col: 1, offset: 12524},
			expr: &litMatcher{
				pos:        position{line: 434, col: 8, offset: 12531},
				val:        "and",
				ignoreCase: true,
				want:       "\"AND\"i",
			},
		},
		{
			name: "Or",
			pos:  position{line: 436, col: 1, offset: 12539},
			expr: &seqExpr{
				pos: position{line: 436, col: 7, offset: 12545},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 436, col: 7, offset: 12545},
						val:        "or",
						ignoreCase: true,
						want:       "\"OR\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 436, col: 13, offset: 12551},
						name: "wss",
					},
				},
			},
		},
		{
			name: "Not",
			pos:  position{line: 438, col: 1, offset: 12556},
			expr: &litMatcher{
				pos:        position{line: 438, col: 8, offset: 12563},
				val:        "not",
				ignoreCase: true,
				want:       "\"NOT\"i",
			},
		},
		{
			name: "GroupBy",
			pos:  position{line: 440, col: 1, offset: 12571},
			expr: &seqExpr{
				pos: position{line: 440, col: 12, offset: 12582},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 440, col: 12, offset: 12582},
						val:        "group",
						ignoreCase: true,
						want:       "\"GROUP\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 440, col: 21, offset: 12591},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 440, col: 24, offset: 12594},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "OrderBy",
			pos:  position{line: 442, col: 1, offset: 12601},
			expr: &seqExpr{
				pos: position{line: 442, col: 12, offset: 12612},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 442, col: 12, offset: 12612},
						val:        "order",
						ignoreCase: true,
						want:       "\"ORDER\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 442, col: 21, offset: 12621},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 442, col: 24, offset: 12624},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "Offset",
			pos:  position{line: 444, col: 1, offset: 12631},
			expr: &litMatcher{
				pos:        position{line: 444, col: 11, offset: 12641},
				val:        "offset",
				ignoreCase: true,
				want:       "\"OFFSET\"i",
			},
		},
		{
			name: "ComparisonOperator",
			pos:  position{line: 446, col: 1, offset: 12652},
			expr: &actionExpr{
				pos: position{line: 446, col: 23, offset: 12674},
				run: (*parser).callonComparisonOperator1,
				expr: &choiceExpr{
					pos: position{line: 446, col: 24, offset: 12675},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 446, col: 24, offset: 12675},
							val:        "<=",
							ignoreCase: false,
							want:       "\"<=\"",
						},
						&litMatcher{
							pos:        position{line: 446, col: 31, offset: 12682},
							val:        ">=",
							ignoreCase: false,
							want:       "\">=\"",
						},
						&litMatcher{
							pos:        position{line: 446, col: 38, offset: 12689},
							val:        "=",
							ignoreCase: false,
							want:       "\"=\"",
						},
						&litMatcher{
							pos:        position{line: 446, col: 44, offset: 12695},
							val:        "!=",
							ignoreCase: false,
							want:       "\"!=\"",
						},
						&litMatcher{
							pos:        position{line: 446, col: 51, offset: 12702},
							val:        "<",
							ignoreCase: false,
							want:       "\"<\"",
						},
						&litMatcher{
							pos:        position{line: 446, col: 57, offset: 12708},
							val:        ">",
							ignoreCase: false,
							want:       "\">\"",
						},
					},
				},
			},
		},
		{
			name: "Literal",
			pos:  position{line: 450, col: 1, offset: 12749},
			expr: &choiceExpr{
				pos: position{line: 450, col: 12, offset: 12760},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 450, col: 12, offset: 12760},
						name: "FloatLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 450, col: 27, offset: 12775},
						name: "IntegerLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 450, col: 44, offset: 12792},
						name: "StringLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 450, col: 60, offset: 12808},
						name: "BooleanLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 450, col: 77, offset: 12825},
						name: "ParameterConstant",
					},
					&ruleRefExpr{
						pos:  position{line: 450, col: 97, offset: 12845},
						name: "NullConstant",
					},
				},
			},
		},
		{
			name: "ParameterConstant",
			pos:  position{line: 452, col: 1, offset: 12859},
			expr: &actionExpr{
				pos: position{line: 452, col: 22, offset: 12880},
				run: (*parser).callonParameterConstant1,
				expr: &seqExpr{
					pos: position{line: 452, col: 22, offset: 12880},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 452, col: 22, offset: 12880},
							val:        "@",
							ignoreCase: false,
							want:       "\"@\"",
						},
						&ruleRefExpr{
							pos:  position{line: 452, col: 26, offset: 12884},
							name: "Identifier",
						},
					},
				},
			},
		},
		{
			name: "NullConstant",
			pos:  position{line: 455, col: 1, offset: 13000},
			expr: &actionExpr{
				pos: position{line: 455, col: 17, offset: 13016},
				run: (*parser).callonNullConstant1,
				expr: &litMatcher{
					pos:        position{line: 455, col: 17, offset: 13016},
					val:        "null",
					ignoreCase: true,
					want:       "\"null\"i",
				},
			},
		},
		{
			name: "IntegerLiteral",
			pos:  position{line: 459, col: 1, offset: 13074},
			expr: &actionExpr{
				pos: position{line: 459, col: 19, offset: 13092},
				run: (*parser).callonIntegerLiteral1,
				expr: &labeledExpr{
					pos:   position{line: 459, col: 19, offset: 13092},
					label: "number",
					expr: &ruleRefExpr{
						pos:  position{line: 459, col: 26, offset: 13099},
						name: "Integer",
					},
				},
			},
		},
		{
			name: "StringLiteral",
			pos:  position{line: 462, col: 1, offset: 13200},
			expr: &actionExpr{
				pos: position{line: 462, col: 18, offset: 13217},
				run: (*parser).callonStringLiteral1,
				expr: &seqExpr{
					pos: position{line: 462, col: 18, offset: 13217},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 462, col: 18, offset: 13217},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 462, col: 23, offset: 13222},
							label: "chars",
							expr: &zeroOrMoreExpr{
								pos: position{line: 462, col: 29, offset: 13228},
								expr: &ruleRefExpr{
									pos:  position{line: 462, col: 29, offset: 13228},
									name: "StringCharacter",
								},
							},
						},
						&litMatcher{
							pos:        position{line: 462, col: 46, offset: 13245},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
					},
				},
			},
		},
		{
			name: "FloatLiteral",
			pos:  position{line: 465, col: 1, offset: 13363},
			expr: &actionExpr{
				pos: position{line: 465, col: 17, offset: 13379},
				run: (*parser).callonFloatLiteral1,
				expr: &seqExpr{
					pos: position{line: 465, col: 17, offset: 13379},
					exprs: []any{
						&oneOrMoreExpr{
							pos: position{line: 465, col: 17, offset: 13379},
							expr: &charClassMatcher{
								pos:        position{line: 465, col: 17, offset: 13379},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
						&litMatcher{
							pos:        position{line: 465, col: 23, offset: 13385},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&oneOrMoreExpr{
							pos: position{line: 465, col: 26, offset: 13388},
							expr: &charClassMatcher{
								pos:        position{line: 465, col: 26, offset: 13388},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "BooleanLiteral",
			pos:  position{line: 469, col: 1, offset: 13544},
			expr: &actionExpr{
				pos: position{line: 469, col: 19, offset: 13562},
				run: (*parser).callonBooleanLiteral1,
				expr: &choiceExpr{
					pos: position{line: 469, col: 20, offset: 13563},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 469, col: 20, offset: 13563},
							val:        "true",
							ignoreCase: true,
							want:       "\"true\"i",
						},
						&litMatcher{
							pos:        position{line: 469, col: 30, offset: 13573},
							val:        "false",
							ignoreCase: true,
							want:       "\"false\"i",
						},
					},
				},
			},
		},
		{
			name: "FunctionCall",
			pos:  position{line: 474, col: 1, offset: 13728},
			expr: &choiceExpr{
				pos: position{line: 474, col: 17, offset: 13744},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 474, col: 17, offset: 13744},
						name: "StringFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 475, col: 7, offset: 13766},
						name: "TypeCheckingFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 476, col: 7, offset: 13794},
						name: "ArrayFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 477, col: 7, offset: 13815},
						name: "ConditionalFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 478, col: 7, offset: 13842},
						name: "InFunction",
					},
					&ruleRefExpr{
						pos:  position{line: 479, col: 7, offset: 13859},
						name: "AggregateFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 480, col: 7, offset: 13884},
						name: "MathFunctions",
					},
				},
			},
		},
		{
			name: "StringFunctions",
			pos:  position{line: 482, col: 1, offset: 13899},
			expr: &choiceExpr{
				pos: position{line: 482, col: 20, offset: 13918},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 482, col: 20, offset: 13918},
						name: "StringEqualsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 483, col: 7, offset: 13947},
						name: "ToStringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 484, col: 7, offset: 13972},
						name: "ConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 485, col: 7, offset: 13995},
						name: "ThreeArgumentStringFunctionExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 486, col: 7, offset: 14039},
						name: "UpperExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 487, col: 7, offset: 14061},
						name: "LowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 488, col: 7, offset: 14083},
						name: "LeftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 489, col: 7, offset: 14104},
						name: "LengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 490, col: 7, offset: 14127},
						name: "LTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 491, col: 7, offset: 14149},
						name: "ReplaceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 492, col: 7, offset: 14173},
						name: "ReplicateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 493, col: 7, offset: 14199},
						name: "ReverseExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 494, col: 7, offset: 14223},
						name: "RightExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 495, col: 7, offset: 14245},
						name: "RTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 496, col: 7, offset: 14267},
						name: "SubstringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 497, col: 7, offset: 14293},
						name: "TrimExpression",
					},
				},
			},
		},
		{
			name: "TypeCheckingFunctions",
			pos:  position{line: 499, col: 1, offset: 14309},
			expr: &choiceExpr{
				pos: position{line: 499, col: 26, offset: 14334},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 499, col: 26, offset: 14334},
						name: "IsDefined",
					},
					&ruleRefExpr{
						pos:  position{line: 500, col: 7, offset: 14350},
						name: "IsArray",
					},
					&ruleRefExpr{
						pos:  position{line: 501, col: 7, offset: 14364},
						name: "IsBool",
					},
					&ruleRefExpr{
						pos:  position{line: 502, col: 7, offset: 14377},
						name: "IsFiniteNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 503, col: 7, offset: 14398},
						name: "IsInteger",
					},
					&ruleRefExpr{
						pos:  position{line: 504, col: 7, offset: 14414},
						name: "IsNull",
					},
					&ruleRefExpr{
						pos:  position{line: 505, col: 7, offset: 14427},
						name: "IsNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 506, col: 7, offset: 14442},
						name: "IsObject",
					},
					&ruleRefExpr{
						pos:  position{line: 507, col: 7, offset: 14457},
						name: "IsPrimitive",
					},
					&ruleRefExpr{
						pos:  position{line: 508, col: 7, offset: 14475},
						name: "IsString",
					},
				},
			},
		},
		{
			name: "AggregateFunctions",
			pos:  position{line: 510, col: 1, offset: 14485},
			expr: &choiceExpr{
				pos: position{line: 510, col: 23, offset: 14507},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 510, col: 23, offset: 14507},
						name: "AvgAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 511, col: 7, offset: 14536},
						name: "CountAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 512, col: 7, offset: 14567},
						name: "MaxAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 513, col: 7, offset: 14596},
						name: "MinAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 514, col: 7, offset: 14625},
						name: "SumAggregateExpression",
					},
				},
			},
		},
		{
			name: "ArrayFunctions",
			pos:  position{line: 516, col: 1, offset: 14649},
			expr: &choiceExpr{
				pos: position{line: 516, col: 19, offset: 14667},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 516, col: 19, offset: 14667},
						name: "ArrayConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 517, col: 7, offset: 14695},
						name: "ArrayContainsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 518, col: 7, offset: 14725},
						name: "ArrayContainsAnyExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 519, col: 7, offset: 14758},
						name: "ArrayContainsAllExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 520, col: 7, offset: 14791},
						name: "ArrayLengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 521, col: 7, offset: 14819},
						name: "ArraySliceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 522, col: 7, offset: 14846},
						name: "SetIntersectExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 523, col: 7, offset: 14875},
						name: "SetUnionExpression",
					},
				},
			},
		},
		{
			name: "ConditionalFunctions",
			pos:  position{line: 525, col: 1, offset: 14895},
			expr: &ruleRefExpr{
				pos:  position{line: 525, col: 25, offset: 14919},
				name: "IifExpression",
			},
		},
		{
			name: "MathFunctions",
			pos:  position{line: 527, col: 1, offset: 14934},
			expr: &choiceExpr{
				pos: position{line: 527, col: 18, offset: 14951},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 527, col: 18, offset: 14951},
						name: "MathAbsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 528, col: 7, offset: 14975},
						name: "MathAcosExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 529, col: 7, offset: 15000},
						name: "MathAsinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 530, col: 7, offset: 15025},
						name: "MathAtanExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 531, col: 7, offset: 15050},
						name: "MathCeilingExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 532, col: 7, offset: 15078},
						name: "MathCosExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 533, col: 7, offset: 15102},
						name: "MathCotExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 534, col: 7, offset: 15126},
						name: "MathDegreesExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 535, col: 7, offset: 15154},
						name: "MathExpExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 536, col: 7, offset: 15178},
						name: "MathFloorExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 537, col: 7, offset: 15204},
						name: "MathIntBitNotExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 538, col: 7, offset: 15234},
						name: "MathLog10Expression",
					},
					&ruleRefExpr{
						pos:  position{line: 539, col: 7, offset: 15260},
						name: "MathRadiansExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 540, col: 7, offset: 15288},
						name: "MathRoundExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 541, col: 7, offset: 15314},
						name: "MathSignExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 542, col: 7, offset: 15339},
						name: "MathSinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 543, col: 7, offset: 15363},
						name: "MathSqrtExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 544, col: 7, offset: 15388},
						name: "MathSquareExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 545, col: 7, offset: 15415},
						name: "MathTanExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 546, col: 7, offset: 15439},
						name: "MathTruncExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 547, col: 7, offset: 15465},
						name: "MathAtn2Expression",
					},
					&ruleRefExpr{
						pos:  position{line: 548, col: 7, offset: 15490},
						name: "MathIntAddExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 549, col: 7, offset: 15517},
						name: "MathIntBitAndExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 550, col: 7, offset: 15547},
						name: "MathIntBitLeftShiftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 551, col: 7, offset: 15583},
						name: "MathIntBitOrExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 552, col: 7, offset: 15612},
						name: "MathIntBitRightShiftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 553, col: 7, offset: 15649},
						name: "MathIntBitXorExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 554, col: 7, offset: 15679},
						name: "MathIntDivExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 555, col: 7, offset: 15706},
						name: "MathIntModExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 556, col: 7, offset: 15733},
						name: "MathIntMulExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 557, col: 7, offset: 15760},
						name: "MathIntSubExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 558, col: 7, offset: 15787},
						name: "MathPowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 559, col: 7, offset: 15813},
						name: "MathLogExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 560, col: 7, offset: 15837},
						name: "MathNumberBinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 561, col: 7, offset: 15867},
						name: "MathPiExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 562, col: 7, offset: 15890},
						name: "MathRandExpression",
					},
				},
			},
		},
		{
			name: "UpperExpression",
			pos:  position{line: 564, col: 1, offset: 15910},
			expr: &actionExpr{
				pos: position{line: 564, col: 20, offset: 15929},
				run: (*parser).callonUpperExpression1,
				expr: &seqExpr{
					pos: position{line: 564, col: 20, offset: 15929},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 564, col: 20, offset: 15929},
							val:        "upper",
							ignoreCase: true,
							want:       "\"UPPER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 564, col: 29, offset: 15938},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 564, col: 32, offset: 15941},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 564, col: 36, offset: 15945},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 564, col: 39, offset: 15948},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 564, col: 50, offset: 15959},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LowerExpression",
			pos:  position{line: 568, col: 1, offset: 16044},
			expr: &actionExpr{
				pos: position{line: 568, col: 20, offset: 16063},
				run: (*parser).callonLowerExpression1,
				expr: &seqExpr{
					pos: position{line: 568, col: 20, offset: 16063},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 568, col: 20, offset: 16063},
							val:        "lower",
							ignoreCase: true,
							want:       "\"LOWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 568, col: 29, offset: 16072},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 568, col: 32, offset: 16075},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 568, col: 36, offset: 16079},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 568, col: 39, offset: 16082},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 568, col: 50, offset: 16093},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "StringEqualsExpression",
			pos:  position{line: 572, col: 1, offset: 16178},
			expr: &actionExpr{
				pos: position{line: 572, col: 27, offset: 16204},
				run: (*parser).callonStringEqualsExpression1,
				expr: &seqExpr{
					pos: position{line: 572, col: 27, offset: 16204},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 572, col: 27, offset: 16204},
							val:        "stringequals",
							ignoreCase: true,
							want:       "\"STRINGEQUALS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 572, col: 43, offset: 16220},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 572, col: 46, offset: 16223},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 572, col: 50, offset: 16227},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 572, col: 53, offset: 16230},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 572, col: 57, offset: 16234},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 572, col: 68, offset: 16245},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 572, col: 71, offset: 16248},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 572, col: 75, offset: 16252},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 572, col: 78, offset: 16255},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 572, col: 82, offset: 16259},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 572, col: 93, offset: 16270},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 572, col: 96, offset: 16273},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 572, col: 107, offset: 16284},
								expr: &actionExpr{
									pos: position{line: 572, col: 108, offset: 16285},
									run: (*parser).callonStringEqualsExpression17,
									expr: &seqExpr{
										pos: position{line: 572, col: 108, offset: 16285},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 572, col: 108, offset: 16285},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 572, col: 112, offset: 16289},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 572, col: 115, offset: 16292},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 572, col: 123, offset: 16300},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 572, col: 160, offset: 16337},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ToStringExpression",
			pos:  position{line: 576, col: 1, offset: 16447},
			expr: &actionExpr{
				pos: position{line: 576, col: 23, offset: 16469},
				run: (*parser).callonToStringExpression1,
				expr: &seqExpr{
					pos: position{line: 576, col: 23, offset: 16469},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 576, col: 23, offset: 16469},
							val:        "tostring",
							ignoreCase: true,
							want:       "\"TOSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 576, col: 35, offset: 16481},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 576, col: 38, offset: 16484},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 576, col: 42, offset: 16488},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 576, col: 45, offset: 16491},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 576, col: 48, offset: 16494},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 576, col: 59, offset: 16505},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 576, col: 62, offset: 16508},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ConcatExpression",
			pos:  position{line: 580, col: 1, offset: 16596},
			expr: &actionExpr{
				pos: position{line: 580, col: 21, offset: 16616},
				run: (*parser).callonConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 580, col: 21, offset: 16616},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 580, col: 21, offset: 16616},
							val:        "concat",
							ignoreCase: true,
							want:       "\"CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 580, col: 31, offset: 16626},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 580, col: 34, offset: 16629},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 580, col: 38, offset: 16633},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 580, col: 41, offset: 16636},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 580, col: 45, offset: 16640},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 580, col: 56, offset: 16651},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 580, col: 63, offset: 16658},
								expr: &actionExpr{
									pos: position{line: 580, col: 64, offset: 16659},
									run: (*parser).callonConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 580, col: 64, offset: 16659},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 580, col: 64, offset: 16659},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 580, col: 67, offset: 16662},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 580, col: 71, offset: 16666},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 580, col: 74, offset: 16669},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 580, col: 77, offset: 16672},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 580, col: 109, offset: 16704},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 580, col: 112, offset: 16707},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LeftExpression",
			pos:  position{line: 585, col: 1, offset: 16856},
			expr: &actionExpr{
				pos: position{line: 585, col: 19, offset: 16874},
				run: (*parser).callonLeftExpression1,
				expr: &seqExpr{
					pos: position{line: 585, col: 19, offset: 16874},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 585, col: 19, offset: 16874},
							val:        "left",
							ignoreCase: true,
							want:       "\"LEFT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 585, col: 27, offset: 16882},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 585, col: 30, offset: 16885},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 585, col: 34, offset: 16889},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 585, col: 37, offset: 16892},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 585, col: 40, offset: 16895},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 585, col: 51, offset: 16906},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 585, col: 54, offset: 16909},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 585, col: 58, offset: 16913},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 585, col: 61, offset: 16916},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 585, col: 68, offset: 16923},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 585, col: 79, offset: 16934},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 585, col: 82, offset: 16937},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LengthExpression",
			pos:  position{line: 589, col: 1, offset: 17029},
			expr: &actionExpr{
				pos: position{line: 589, col: 21, offset: 17049},
				run: (*parser).callonLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 589, col: 21, offset: 17049},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 589, col: 21, offset: 17049},
							val:        "length",
							ignoreCase: true,
							want:       "\"LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 589, col: 31, offset: 17059},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 589, col: 34, offset: 17062},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 589, col: 38, offset: 17066},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 589, col: 41, offset: 17069},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 589, col: 44, offset: 17072},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 589, col: 55, offset: 17083},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 589, col: 58, offset: 17086},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LTrimExpression",
			pos:  position{line: 593, col: 1, offset: 17172},
			expr: &actionExpr{
				pos: position{line: 593, col: 20, offset: 17191},
				run: (*parser).callonLTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 593, col: 20, offset: 17191},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 593, col: 20, offset: 17191},
							val:        "ltrim",
							ignoreCase: true,
							want:       "\"LTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 593, col: 29, offset: 17200},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 593, col: 32, offset: 17203},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 593, col: 36, offset: 17207},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 593, col: 39, offset: 17210},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 593, col: 42, offset: 17213},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 593, col: 53, offset: 17224},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 593, col: 56, offset: 17227},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplaceExpression",
			pos:  position{line: 597, col: 1, offset: 17312},
			expr: &actionExpr{
				pos: position{line: 597, col: 22, offset: 17333},
				run: (*parser).callonReplaceExpression1,
				expr: &seqExpr{
					pos: position{line: 597, col: 22, offset: 17333},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 597, col: 22, offset: 17333},
							val:        "replace",
							ignoreCase: true,
							want:       "\"REPLACE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 33, offset: 17344},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 597, col: 36, offset: 17347},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 40, offset: 17351},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 597, col: 43, offset: 17354},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 597, col: 47, offset: 17358},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 58, offset: 17369},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 597, col: 61, offset: 17372},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 65, offset: 17376},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 597, col: 68, offset: 17379},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 597, col: 72, offset: 17383},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 83, offset: 17394},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 597, col: 86, offset: 17397},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 90, offset: 17401},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 597, col: 93, offset: 17404},
							label: "ex3",
							expr: &ruleRefExpr{
								pos:  position{line: 597, col: 97, offset: 17408},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 597, col: 108, offset: 17419},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 597, col: 111, offset: 17422},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplicateExpression",
			pos:  position{line: 601, col: 1, offset: 17520},
			expr: &actionExpr{
				pos: position{line: 601, col: 24, offset: 17543},
				run: (*parser).callonReplicateExpression1,
				expr: &seqExpr{
					pos: position{line: 601, col: 24, offset: 17543},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 601, col: 24, offset: 17543},
							val:        "replicate",
							ignoreCase: true,
							want:       "\"REPLICATE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 601, col: 37, offset: 17556},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 601, col: 40, offset: 17559},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 601, col: 44, offset: 17563},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 601, col: 47, offset: 17566},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 601, col: 51, offset: 17570},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 601, col: 62, offset: 17581},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 601, col: 65, offset: 17584},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 601, col: 69, offset: 17588},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 601, col: 72, offset: 17591},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 601, col: 76, offset: 17595},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 601, col: 87, offset: 17606},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 601, col: 90, offset: 17609},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReverseExpression",
			pos:  position{line: 605, col: 1, offset: 17704},
			expr: &actionExpr{
				pos: position{line: 605, col: 22, offset: 17725},
				run: (*parser).callonReverseExpression1,
				expr: &seqExpr{
					pos: position{line: 605, col: 22, offset: 17725},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 605, col: 22, offset: 17725},
							val:        "reverse",
							ignoreCase: true,
							want:       "\"REVERSE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 605, col: 33, offset: 17736},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 605, col: 36, offset: 17739},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 605, col: 40, offset: 17743},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 605, col: 43, offset: 17746},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 605, col: 46, offset: 17749},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 605, col: 57, offset: 17760},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 605, col: 60, offset: 17763},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RightExpression",
			pos:  position{line: 609, col: 1, offset: 17850},
			expr: &actionExpr{
				pos: position{line: 609, col: 20, offset: 17869},
				run: (*parser).callonRightExpression1,
				expr: &seqExpr{
					pos: position{line: 609, col: 20, offset: 17869},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 609, col: 20, offset: 17869},
							val:        "right",
							ignoreCase: true,
							want:       "\"RIGHT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 609, col: 29, offset: 17878},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 609, col: 32, offset: 17881},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 609, col: 36, offset: 17885},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 609, col: 39, offset: 17888},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 609, col: 42, offset: 17891},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 609, col: 53, offset: 17902},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 609, col: 56, offset: 17905},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 609, col: 60, offset: 17909},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 609, col: 63, offset: 17912},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 609, col: 70, offset: 17919},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 609, col: 81, offset: 17930},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 609, col: 84, offset: 17933},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RTrimExpression",
			pos:  position{line: 613, col: 1, offset: 18026},
			expr: &actionExpr{
				pos: position{line: 613, col: 20, offset: 18045},
				run: (*parser).callonRTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 613, col: 20, offset: 18045},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 613, col: 20, offset: 18045},
							val:        "rtrim",
							ignoreCase: true,
							want:       "\"RTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 613, col: 29, offset: 18054},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 613, col: 32, offset: 18057},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 613, col: 36, offset: 18061},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 613, col: 39, offset: 18064},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 613, col: 42, offset: 18067},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 613, col: 53, offset: 18078},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 613, col: 56, offset: 18081},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubstringExpression",
			pos:  position{line: 617, col: 1, offset: 18166},
			expr: &actionExpr{
				pos: position{line: 617, col: 24, offset: 18189},
				run: (*parser).callonSubstringExpression1,
				expr: &seqExpr{
					pos: position{line: 617, col: 24, offset: 18189},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 617, col: 24, offset: 18189},
							val:        "substring",
							ignoreCase: true,
							want:       "\"SUBSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 617, col: 37, offset: 18202},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 617, col: 40, offset: 18205},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 617, col: 44, offset: 18209},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 617, col: 47, offset: 18212},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 617, col: 50, offset: 18215},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 617, col: 61, offset: 18226},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 617, col: 64, offset: 18229},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 617, col: 68, offset: 18233},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 617, col: 71, offset: 18236},
							label: "startPos",
							expr: &ruleRefExpr{
								pos:  position{line: 617, col: 80, offset: 18245},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 617, col: 91, offset: 18256},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 617, col: 94, offset: 18259},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 617, col: 98, offset: 18263},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 617, col: 101, offset: 18266},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 617, col: 108, offset: 18273},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 617, col: 119, offset: 18284},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 617, col: 122, offset: 18287},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "TrimExpression",
			pos:  position{line: 621, col: 1, offset: 18394},
			expr: &actionExpr{
				pos: position{line: 621, col: 19, offset: 18412},
				run: (*parser).callonTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 621, col: 19, offset: 18412},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 621, col: 19, offset: 18412},
							val:        "trim",
							ignoreCase: true,
							want:       "\"TRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 621, col: 27, offset: 18420},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 621, col: 30, offset: 18423},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 621, col: 34, offset: 18427},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 621, col: 37, offset: 18430},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 621, col: 40, offset: 18433},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 621, col: 51, offset: 18444},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 621, col: 54, offset: 18447},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunctionExpression",
			pos:  position{line: 625, col: 1, offset: 18531},
			expr: &actionExpr{
				pos: position{line: 625, col: 42, offset: 18572},
				run: (*parser).callonThreeArgumentStringFunctionExpression1,
				expr: &seqExpr{
					pos: position{line: 625, col: 42, offset: 18572},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 625, col: 42, offset: 18572},
							label: "function",
							expr: &ruleRefExpr{
								pos:  position{line: 625, col: 51, offset: 18581},
								name: "ThreeArgumentStringFunction",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 625, col: 79, offset: 18609},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 625, col: 82, offset: 18612},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 625, col: 86, offset: 18616},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 625, col: 89, offset: 18619},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 625, col: 93, offset: 18623},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 625, col: 104, offset: 18634},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 625, col: 107, offset: 18637},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 625, col: 111, offset: 18641},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 625, col: 114, offset: 18644},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 625, col: 118, offset: 18648},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 625, col: 129, offset: 18659},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 625, col: 132, offset: 18662},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 625, col: 143, offset: 18673},
								expr: &actionExpr{
									pos: position{line: 625, col: 144, offset: 18674},
									run: (*parser).callonThreeArgumentStringFunctionExpression18,
									expr: &seqExpr{
										pos: position{line: 625, col: 144, offset: 18674},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 625, col: 144, offset: 18674},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 625, col: 148, offset: 18678},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 625, col: 151, offset: 18681},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 625, col: 159, offset: 18689},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 625, col: 196, offset: 18726},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunction",
			pos:  position{line: 643, col: 1, offset: 19248},
			expr: &actionExpr{
				pos: position{line: 643, col: 32, offset: 19279},
				run: (*parser).callonThreeArgumentStringFunction1,
				expr: &choiceExpr{
					pos: position{line: 643, col: 33, offset: 19280},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 643, col: 33, offset: 19280},
							val:        "contains",
							ignoreCase: true,
							want:       "\"CONTAINS\"i",
						},
						&litMatcher{
							pos:        position{line: 643, col: 47, offset: 19294},
							val:        "endswith",
							ignoreCase: true,
							want:       "\"ENDSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 643, col: 61, offset: 19308},
							val:        "startswith",
							ignoreCase: true,
							want:       "\"STARTSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 643, col: 77, offset: 19324},
							val:        "index_of",
							ignoreCase: true,
							want:       "\"INDEX_OF\"i",
						},
					},
				},
			},
		},
		{
			name: "IsDefined",
			pos:  position{line: 647, col: 1, offset: 19373},
			expr: &actionExpr{
				pos: position{line: 647, col: 14, offset: 19386},
				run: (*parser).callonIsDefined1,
				expr: &seqExpr{
					pos: position{line: 647, col: 14, offset: 19386},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 647, col: 14, offset: 19386},
							val:        "is_defined",
							ignoreCase: true,
							want:       "\"IS_DEFINED\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 647, col: 28, offset: 19400},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 647, col: 31, offset: 19403},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 647, col: 35, offset: 19407},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 647, col: 38, offset: 19410},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 647, col: 41, offset: 19413},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 647, col: 52, offset: 19424},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 647, col: 55, offset: 19427},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsArray",
			pos:  position{line: 651, col: 1, offset: 19516},
			expr: &actionExpr{
				pos: position{line: 651, col: 12, offset: 19527},
				run: (*parser).callonIsArray1,
				expr: &seqExpr{
					pos: position{line: 651, col: 12, offset: 19527},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 651, col: 12, offset: 19527},
							val:        "is_array",
							ignoreCase: true,
							want:       "\"IS_ARRAY\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 651, col: 24, offset: 19539},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 651, col: 27, offset: 19542},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 651, col: 31, offset: 19546},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 651, col: 34, offset: 19549},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 651, col: 37, offset: 19552},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 651, col: 48, offset: 19563},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 651, col: 51, offset: 19566},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsBool",
			pos:  position{line: 655, col: 1, offset: 19653},
			expr: &actionExpr{
				pos: position{line: 655, col: 11, offset: 19663},
				run: (*parser).callonIsBool1,
				expr: &seqExpr{
					pos: position{line: 655, col: 11, offset: 19663},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 655, col: 11, offset: 19663},
							val:        "is_bool",
							ignoreCase: true,
							want:       "\"IS_BOOL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 655, col: 22, offset: 19674},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 655, col: 25, offset: 19677},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 655, col: 29, offset: 19681},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 655, col: 32, offset: 19684},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 655, col: 35, offset: 19687},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 655, col: 46, offset: 19698},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 655, col: 49, offset: 19701},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsFiniteNumber",
			pos:  position{line: 659, col: 1, offset: 19787},
			expr: &actionExpr{
				pos: position{line: 659, col: 19, offset: 19805},
				run: (*parser).callonIsFiniteNumber1,
				expr: &seqExpr{
					pos: position{line: 659, col: 19, offset: 19805},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 659, col: 19, offset: 19805},
							val:        "is_finite_number",
							ignoreCase: true,
							want:       "\"IS_FINITE_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 659, col: 39, offset: 19825},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 659, col: 42, offset: 19828},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 659, col: 46, offset: 19832},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 659, col: 49, offset: 19835},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 659, col: 52, offset: 19838},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 659, col: 63, offset: 19849},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 659, col: 66, offset: 19852},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsInteger",
			pos:  position{line: 663, col: 1, offset: 19946},
			expr: &actionExpr{
				pos: position{line: 663, col: 14, offset: 19959},
				run: (*parser).callonIsInteger1,
				expr: &seqExpr{
					pos: position{line: 663, col: 14, offset: 19959},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 663, col: 14, offset: 19959},
							val:        "is_integer",
							ignoreCase: true,
							want:       "\"IS_INTEGER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 663, col: 28, offset: 19973},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 663, col: 31, offset: 19976},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 663, col: 35, offset: 19980},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 663, col: 38, offset: 19983},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 663, col: 41, offset: 19986},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 663, col: 52, offset: 19997},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 663, col: 55, offset: 20000},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNull",
			pos:  position{line: 667, col: 1, offset: 20089},
			expr: &actionExpr{
				pos: position{line: 667, col: 11, offset: 20099},
				run: (*parser).callonIsNull1,
				expr: &seqExpr{
					pos: position{line: 667, col: 11, offset: 20099},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 667, col: 11, offset: 20099},
							val:        "is_null",
							ignoreCase: true,
							want:       "\"IS_NULL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 667, col: 22, offset: 20110},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 667, col: 25, offset: 20113},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 667, col: 29, offset: 20117},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 667, col: 32, offset: 20120},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 667, col: 35, offset: 20123},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 667, col: 46, offset: 20134},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 667, col: 49, offset: 20137},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNumber",
			pos:  position{line: 671, col: 1, offset: 20223},
			expr: &actionExpr{
				pos: position{line: 671, col: 13, offset: 20235},
				run: (*parser).callonIsNumber1,
				expr: &seqExpr{
					pos: position{line: 671, col: 13, offset: 20235},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 671, col: 13, offset: 20235},
							val:        "is_number",
							ignoreCase: true,
							want:       "\"IS_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 671, col: 26, offset: 20248},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 671, col: 29, offset: 20251},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 671, col: 33, offset: 20255},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 671, col: 36, offset: 20258},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 671, col: 39, offset: 20261},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 671, col: 50, offset: 20272},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 671, col: 53, offset: 20275},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsObject",
			pos:  position{line: 675, col: 1, offset: 20363},
			expr: &actionExpr{
				pos: position{line: 675, col: 13, offset: 20375},
				run: (*parser).callonIsObject1,
				expr: &seqExpr{
					pos: position{line: 675, col: 13, offset: 20375},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 675, col: 13, offset: 20375},
							val:        "is_object",
							ignoreCase: true,
							want:       "\"IS_OBJECT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 675, col: 26, offset: 20388},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 675, col: 29, offset: 20391},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 675, col: 33, offset: 20395},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 675, col: 36, offset: 20398},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 675, col: 39, offset: 20401},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 675, col: 50, offset: 20412},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 675, col: 53, offset: 20415},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsPrimitive",
			pos:  position{line: 679, col: 1, offset: 20503},
			expr: &actionExpr{
				pos: position{line: 679, col: 16, offset: 20518},
				run: (*parser).callonIsPrimitive1,
				expr: &seqExpr{
					pos: position{line: 679, col: 16, offset: 20518},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 679, col: 16, offset: 20518},
							val:        "is_primitive",
							ignoreCase: true,
							want:       "\"IS_PRIMITIVE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 679, col: 32, offset: 20534},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 679, col: 35, offset: 20537},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 679, col: 39, offset: 20541},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 679, col: 42, offset: 20544},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 679, col: 45, offset: 20547},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 679, col: 56, offset: 20558},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 679, col: 59, offset: 20561},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsString",
			pos:  position{line: 683, col: 1, offset: 20652},
			expr: &actionExpr{
				pos: position{line: 683, col: 13, offset: 20664},
				run: (*parser).callonIsString1,
				expr: &seqExpr{
					pos: position{line: 683, col: 13, offset: 20664},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 683, col: 13, offset: 20664},
							val:        "is_string",
							ignoreCase: true,
							want:       "\"IS_STRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 683, col: 26, offset: 20677},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 683, col: 29, offset: 20680},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 683, col: 33, offset: 20684},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 683, col: 36, offset: 20687},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 683, col: 39, offset: 20690},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 683, col: 50, offset: 20701},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 683, col: 53, offset: 20704},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayConcatExpression",
			pos:  position{line: 687, col: 1, offset: 20792},
			expr: &actionExpr{
				pos: position{line: 687, col: 26, offset: 20817},
				run: (*parser).callonArrayConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 687, col: 26, offset: 20817},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 687, col: 26, offset: 20817},
							val:        "array_concat",
							ignoreCase: true,
							want:       "\"ARRAY_CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 687, col: 42, offset: 20833},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 687, col: 45, offset: 20836},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 687, col: 49, offset: 20840},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 687, col: 52, offset: 20843},
							label: "arrays",
							expr: &ruleRefExpr{
								pos:  position{line: 687, col: 59, offset: 20850},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 687, col: 70, offset: 20861},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 687, col: 77, offset: 20868},
								expr: &actionExpr{
									pos: position{line: 687, col: 78, offset: 20869},
									run: (*parser).callonArrayConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 687, col: 78, offset: 20869},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 687, col: 78, offset: 20869},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 687, col: 81, offset: 20872},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 687, col: 85, offset: 20876},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 687, col: 88, offset: 20879},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 687, col: 91, offset: 20882},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 687, col: 123, offset: 20914},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 687, col: 126, offset: 20917},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayContainsExpression",
			pos:  position{line: 691, col: 1, offset: 21047},
			expr: &actionExpr{
				pos: position{line: 691, col: 28, offset: 21074},
				run: (*parser).callonArrayContainsExpression1,
				expr: &seqExpr{
					pos: position{line: 691, col: 28, offset: 21074},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 691, col: 28, offset: 21074},
							val:        "array_contains",
							ignoreCase: true,
							want:       "\"ARRAY_CONTAINS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 691, col: 46, offset: 21092},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 691, col: 49, offset: 21095},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 691, col: 53, offset: 21099},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 691, col: 56, offset: 21102},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 691, col: 62, offset: 21108},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 691, col: 73, offset: 21119},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 691, col: 76, offset: 21122},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 691, col: 80, offset: 21126},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 691, col: 83, offset: 21129},
							label: "item",
							expr: &ruleRefExpr{
								pos:  position{line: 691, col: 88, offset: 21134},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 691, col: 99, offset: 21145},
							label: "partialMatch",
							expr: &zeroOrOneExpr{
								pos: position{line: 691, col: 112, offset: 21158},
								expr: &actionExpr{
									pos: position{line: 691, col: 113, offset: 21159},
									run: (*parser).callonArrayContainsExpression16,
									expr: &seqExpr{
										pos: position{line: 691, col: 113, offset: 21159},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 691, col: 113, offset: 21159},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 691, col: 116, offset: 21162},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 691, col: 120, offset: 21166},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 691, col: 123, offset: 21169},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 691, col: 126, offset: 21172},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 691, col: 158, offset: 21204},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 691, col: 161, offset: 21207},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayContainsAnyExpression",
			pos:  position{line: 695, col: 1, offset: 21323},
			expr: &actionExpr{
				pos: position{line: 695, col: 31, offset: 21353},
				run: (*parser).callonArrayContainsAnyExpression1,
				expr: &seqExpr{
					pos: position{line: 695, col: 31, offset: 21353},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 695, col: 31, offset: 21353},
							val:        "array_contains_any",
							ignoreCase: true,
							want:       "\"ARRAY_CONTAINS_ANY\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 695, col: 53, offset: 21375},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 695, col: 56, offset: 21378},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 695, col: 60, offset: 21382},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 695, col: 63, offset: 21385},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 695, col: 69, offset: 21391},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 695, col: 80, offset: 21402},
							label: "items",
							expr: &oneOrMoreExpr{
								pos: position{line: 695, col: 86, offset: 21408},
								expr: &actionExpr{
									pos: position{line: 695, col: 87, offset: 21409},
									run: (*parser).callonArrayContainsAnyExpression11,
									expr: &seqExpr{
										pos: position{line: 695, col: 87, offset: 21409},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 695, col: 87, offset: 21409},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 695, col: 90, offset: 21412},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 695, col: 94, offset: 21416},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 695, col: 97, offset: 21419},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 695, col: 100, offset: 21422},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 695, col: 132, offset: 21454},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 695, col: 135, offset: 21457},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayContainsAllExpression",
			pos:  position{line: 699, col: 1, offset: 21590},
			expr: &actionExpr{
				pos: position{line: 699, col: 31, offset: 21620},
				run: (*parser).callonArrayContainsAllExpression1,
				expr: &seqExpr{
					pos: position{line: 699, col: 31, offset: 21620},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 699, col: 31, offset: 21620},
							val:        "array_contains_all",
							ignoreCase: true,
							want:       "\"ARRAY_CONTAINS_ALL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 53, offset: 21642},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 699, col: 56, offset: 21645},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 60, offset: 21649},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 699, col: 63, offset: 21652},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 699, col: 69, offset: 21658},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 699, col: 80, offset: 21669},
							label: "items",
							expr: &oneOrMoreExpr{
								pos: position{line: 699, col: 86, offset: 21675},
								expr: &actionExpr{
									pos: position{line: 699, col: 87, offset: 21676},
									run: (*parser).callonArrayContainsAllExpression11,
									expr: &seqExpr{
										pos: position{line: 699, col: 87, offset: 21676},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 699, col: 87, offset: 21676},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 699, col: 90, offset: 21679},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 699, col: 94, offset: 21683},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 699, col: 97, offset: 21686},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 699, col: 100, offset: 21689},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 132, offset: 21721},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 699, col: 135, offset: 21724},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayLengthExpression",
			pos:  position{line: 703, col: 1, offset: 21857},
			expr: &actionExpr{
				pos: position{line: 703, col: 26, offset: 21882},
				run: (*parser).callonArrayLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 703, col: 26, offset: 21882},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 703, col: 26, offset: 21882},
							val:        "array_length",
							ignoreCase: true,
							want:       "\"ARRAY_LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 42, offset: 21898},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 703, col: 45, offset: 21901},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 49, offset: 21905},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 703, col: 52, offset: 21908},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 703, col: 58, offset: 21914},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 69, offset: 21925},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 703, col: 72, offset: 21928},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArraySliceExpression",
			pos:  position{line: 707, col: 1, offset: 22022},
			expr: &actionExpr{
				pos: position{line: 707, col: 25, offset: 22046},
				run: (*parser).callonArraySliceExpression1,
				expr: &seqExpr{
					pos: position{line: 707, col: 25, offset: 22046},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 707, col: 25, offset: 22046},
							val:        "array_slice",
							ignoreCase: true,
							want:       "\"ARRAY_SLICE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 40, offset: 22061},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 707, col: 43, offset: 22064},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 47, offset: 22068},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 707, col: 50, offset: 22071},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 707, col: 56, offset: 22077},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 67, offset: 22088},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 707, col: 70, offset: 22091},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 74, offset: 22095},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 707, col: 77, offset: 22098},
							label: "start",
							expr: &ruleRefExpr{
								pos:  position{line: 707, col: 83, offset: 22104},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 707, col: 94, offset: 22115},
							label: "length",
							expr: &zeroOrOneExpr{
								pos: position{line: 707, col: 101, offset: 22122},
								expr: &actionExpr{
									pos: position{line: 707, col: 102, offset: 22123},
									run: (*parser).callonArraySliceExpression16,
									expr: &seqExpr{
										pos: position{line: 707, col: 102, offset: 22123},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 707, col: 102, offset: 22123},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 707, col: 105, offset: 22126},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 707, col: 109, offset: 22130},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 707, col: 112, offset: 22133},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 707, col: 115, offset: 22136},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 147, offset: 22168},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 707, col: 150, offset: 22171},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetIntersectExpression",
			pos:  position{line: 711, col: 1, offset: 22279},
			expr: &actionExpr{
				pos: position{line: 711, col: 27, offset: 22305},
				run: (*parser).callonSetIntersectExpression1,
				expr: &seqExpr{
					pos: position{line: 711, col: 27, offset: 22305},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 711, col: 27, offset: 22305},
							val:        "setintersect",
							ignoreCase: true,
							want:       "\"SetIntersect\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 43, offset: 22321},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 711, col: 46, offset: 22324},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 50, offset: 22328},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 711, col: 53, offset: 22331},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 711, col: 58, offset: 22336},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 69, offset: 22347},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 711, col: 72, offset: 22350},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 76, offset: 22354},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 711, col: 79, offset: 22357},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 711, col: 84, offset: 22362},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 95, offset: 22373},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 711, col: 98, offset: 22376},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetUnionExpression",
			pos:  position{line: 715, col: 1, offset: 22476},
			expr: &actionExpr{
				pos: position{line: 715, col: 23, offset: 22498},
				run: (*parser).callonSetUnionExpression1,
				expr: &seqExpr{
					pos: position{line: 715, col: 23, offset: 22498},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 715, col: 23, offset: 22498},
							val:        "setunion",
							ignoreCase: true,
							want:       "\"SetUnion\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 35, offset: 22510},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 715, col: 38, offset: 22513},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 42, offset: 22517},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 715, col: 45, offset: 22520},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 715, col: 50, offset: 22525},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 61, offset: 22536},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 715, col: 64, offset: 22539},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 68, offset: 22543},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 715, col: 71, offset: 22546},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 715, col: 76, offset: 22551},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 87, offset: 22562},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 715, col: 90, offset: 22565},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IifExpression",
			pos:  position{line: 719, col: 1, offset: 22661},
			expr: &actionExpr{
				pos: position{line: 719, col: 18, offset: 22678},
				run: (*parser).callonIifExpression1,
				expr: &seqExpr{
					pos: position{line: 719, col: 18, offset: 22678},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 719, col: 18, offset: 22678},
							val:        "iif",
							ignoreCase: true,
							want:       "\"IIF\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 25, offset: 22685},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 719, col: 28, offset: 22688},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 32, offset: 22692},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 719, col: 35, offset: 22695},
							label: "condition",
							expr: &ruleRefExpr{
								pos:  position{line: 719, col: 45, offset: 22705},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 56, offset: 22716},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 719, col: 59, offset: 22719},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 63, offset: 22723},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 719, col: 66, offset: 22726},
							label: "trueValue",
							expr: &ruleRefExpr{
								pos:  position{line: 719, col: 76, offset: 22736},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 87, offset: 22747},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 719, col: 90, offset: 22750},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 94, offset: 22754},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 719, col: 97, offset: 22757},
							label: "falseValue",
							expr: &ruleRefExpr{
								pos:  position{line: 719, col: 108, offset: 22768},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 719, col: 119, offset: 22779},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 719, col: 122, offset: 22782},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAbsExpression",
			pos:  position{line: 723, col: 1, offset: 22895},
			expr: &actionExpr{
				pos: position{line: 723, col: 22, offset: 22916},
				run: (*parser).callonMathAbsExpression1,
				expr: &seqExpr{
					pos: position{line: 723, col: 22, offset: 22916},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 723, col: 22, offset: 22916},
							val:        "abs",
							ignoreCase: true,
							want:       "\"ABS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 723, col: 29, offset: 22923},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 723, col: 32, offset: 22926},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 723, col: 36, offset: 22930},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 723, col: 39, offset: 22933},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 723, col: 42, offset: 22936},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 723, col: 53, offset: 22947},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 723, col: 56, offset: 22950},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAcosExpression",
			pos:  position{line: 724, col: 1, offset: 23032},
			expr: &actionExpr{
				pos: position{line: 724, col: 23, offset: 23054},
				run: (*parser).callonMathAcosExpression1,
				expr: &seqExpr{
					pos: position{line: 724, col: 23, offset: 23054},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 724, col: 23, offset: 23054},
							val:        "acos",
							ignoreCase: true,
							want:       "\"ACOS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 724, col: 31, offset: 23062},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 724, col: 34, offset: 23065},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 724, col: 38, offset: 23069},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 724, col: 41, offset: 23072},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 724, col: 44, offset: 23075},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 724, col: 55, offset: 23086},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 724, col: 58, offset: 23089},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAsinExpression",
			pos:  position{line: 725, col: 1, offset: 23172},
			expr: &actionExpr{
				pos: position{line: 725, col: 23, offset: 23194},
				run: (*parser).callonMathAsinExpression1,
				expr: &seqExpr{
					pos: position{line: 725, col: 23, offset: 23194},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 725, col: 23, offset: 23194},
							val:        "asin",
							ignoreCase: true,
							want:       "\"ASIN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 725, col: 31, offset: 23202},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 725, col: 34, offset: 23205},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 725, col: 38, offset: 23209},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 725, col: 41, offset: 23212},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 725, col: 44, offset: 23215},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 725, col: 55, offset: 23226},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 725, col: 58, offset: 23229},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAtanExpression",
			pos:  position{line: 726, col: 1, offset: 23312},
			expr: &actionExpr{
				pos: position{line: 726, col: 23, offset: 23334},
				run: (*parser).callonMathAtanExpression1,
				expr: &seqExpr{
					pos: position{line: 726, col: 23, offset: 23334},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 726, col: 23, offset: 23334},
							val:        "atan",
							ignoreCase: true,
							want:       "\"ATAN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 726, col: 31, offset: 23342},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 726, col: 34, offset: 23345},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 726, col: 38, offset: 23349},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 726, col: 41, offset: 23352},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 726, col: 44, offset: 23355},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 726, col: 55, offset: 23366},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 726, col: 58, offset: 23369},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCeilingExpression",
			pos:  position{line: 727, col: 1, offset: 23452},
			expr: &actionExpr{
				pos: position{line: 727, col: 26, offset: 23477},
				run: (*parser).callonMathCeilingExpression1,
				expr: &seqExpr{
					pos: position{line: 727, col: 26, offset: 23477},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 727, col: 26, offset: 23477},
							val:        "ceiling",
							ignoreCase: true,
							want:       "\"CEILING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 727, col: 37, offset: 23488},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 727, col: 40, offset: 23491},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 727, col: 44, offset: 23495},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 727, col: 47, offset: 23498},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 727, col: 50, offset: 23501},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 727, col: 61, offset: 23512},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 727, col: 64, offset: 23515},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCosExpression",
			pos:  position{line: 728, col: 1, offset: 23601},
			expr: &actionExpr{
				pos: position{line: 728, col: 22, offset: 23622},
				run: (*parser).callonMathCosExpression1,
				expr: &seqExpr{
					pos: position{line: 728, col: 22, offset: 23622},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 728, col: 22, offset: 23622},
							val:        "cos",
							ignoreCase: true,
							want:       "\"COS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 728, col: 29, offset: 23629},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 728, col: 32, offset: 23632},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 728, col: 36, offset: 23636},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 728, col: 39, offset: 23639},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 728, col: 42, offset: 23642},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 728, col: 53, offset: 23653},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 728, col: 56, offset: 23656},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCotExpression",
			pos:  position{line: 729, col: 1, offset: 23738},
			expr: &actionExpr{
				pos: position{line: 729, col: 22, offset: 23759},
				run: (*parser).callonMathCotExpression1,
				expr: &seqExpr{
					pos: position{line: 729, col: 22, offset: 23759},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 729, col: 22, offset: 23759},
							val:        "cot",
							ignoreCase: true,
							want:       "\"COT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 729, col: 29, offset: 23766},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 729, col: 32, offset: 23769},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 729, col: 36, offset: 23773},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 729, col: 39, offset: 23776},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 729, col: 42, offset: 23779},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 729, col: 53, offset: 23790},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 729, col: 56, offset: 23793},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathDegreesExpression",
			pos:  position{line: 730, col: 1, offset: 23875},
			expr: &actionExpr{
				pos: position{line: 730, col: 26, offset: 23900},
				run: (*parser).callonMathDegreesExpression1,
				expr: &seqExpr{
					pos: position{line: 730, col: 26, offset: 23900},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 730, col: 26, offset: 23900},
							val:        "degrees",
							ignoreCase: true,
							want:       "\"DEGREES\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 730, col: 37, offset: 23911},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 730, col: 40, offset: 23914},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 730, col: 44, offset: 23918},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 730, col: 47, offset: 23921},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 730, col: 50, offset: 23924},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 730, col: 61, offset: 23935},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 730, col: 64, offset: 23938},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathExpExpression",
			pos:  position{line: 731, col: 1, offset: 24024},
			expr: &actionExpr{
				pos: position{line: 731, col: 22, offset: 24045},
				run: (*parser).callonMathExpExpression1,
				expr: &seqExpr{
					pos: position{line: 731, col: 22, offset: 24045},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 731, col: 22, offset: 24045},
							val:        "exp",
							ignoreCase: true,
							want:       "\"EXP\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 731, col: 29, offset: 24052},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 731, col: 32, offset: 24055},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 731, col: 36, offset: 24059},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 731, col: 39, offset: 24062},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 731, col: 42, offset: 24065},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 731, col: 53, offset: 24076},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 731, col: 56, offset: 24079},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathFloorExpression",
			pos:  position{line: 732, col: 1, offset: 24161},
			expr: &actionExpr{
				pos: position{line: 732, col: 24, offset: 24184},
				run: (*parser).callonMathFloorExpression1,
				expr: &seqExpr{
					pos: position{line: 732, col: 24, offset: 24184},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 732, col: 24, offset: 24184},
							val:        "floor",
							ignoreCase: true,
							want:       "\"FLOOR\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 732, col: 33, offset: 24193},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 732, col: 36, offset: 24196},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 732, col: 40, offset: 24200},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 732, col: 43, offset: 24203},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 732, col: 46, offset: 24206},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 732, col: 57, offset: 24217},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 732, col: 60, offset: 24220},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitNotExpression",
			pos:  position{line: 733, col: 1, offset: 24304},
			expr: &actionExpr{
				pos: position{line: 733, col: 28, offset: 24331},
				run: (*parser).callonMathIntBitNotExpression1,
				expr: &seqExpr{
					pos: position{line: 733, col: 28, offset: 24331},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 733, col: 28, offset: 24331},
							val:        "intbitnot",
							ignoreCase: true,
							want:       "\"IntBitNot\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 733, col: 41, offset: 24344},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 733, col: 44, offset: 24347},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 733, col: 48, offset: 24351},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 733, col: 51, offset: 24354},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 733, col: 54, offset: 24357},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 733, col: 65, offset: 24368},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 733, col: 68, offset: 24371},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathLog10Expression",
			pos:  position{line: 734, col: 1, offset: 24459},
			expr: &actionExpr{
				pos: position{line: 734, col: 24, offset: 24482},
				run: (*parser).callonMathLog10Expression1,
				expr: &seqExpr{
					pos: position{line: 734, col: 24, offset: 24482},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 734, col: 24, offset: 24482},
							val:        "log10",
							ignoreCase: true,
							want:       "\"LOG10\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 734, col: 33, offset: 24491},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 734, col: 36, offset: 24494},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 734, col: 40, offset: 24498},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 734, col: 43, offset: 24501},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 734, col: 46, offset: 24504},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 734, col: 57, offset: 24515},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 734, col: 60, offset: 24518},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRadiansExpression",
			pos:  position{line: 735, col: 1, offset: 24602},
			expr: &actionExpr{
				pos: position{line: 735, col: 26, offset: 24627},
				run: (*parser).callonMathRadiansExpression1,
				expr: &seqExpr{
					pos: position{line: 735, col: 26, offset: 24627},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 735, col: 26, offset: 24627},
							val:        "radians",
							ignoreCase: true,
							want:       "\"RADIANS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 735, col: 37, offset: 24638},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 735, col: 40, offset: 24641},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 735, col: 44, offset: 24645},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 735, col: 47, offset: 24648},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 735, col: 50, offset: 24651},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 735, col: 61, offset: 24662},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 735, col: 64, offset: 24665},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRoundExpression",
			pos:  position{line: 736, col: 1, offset: 24751},
			expr: &actionExpr{
				pos: position{line: 736, col: 24, offset: 24774},
				run: (*parser).callonMathRoundExpression1,
				expr: &seqExpr{
					pos: position{line: 736, col: 24, offset: 24774},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 736, col: 24, offset: 24774},
							val:        "round",
							ignoreCase: true,
							want:       "\"ROUND\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 736, col: 33, offset: 24783},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 736, col: 36, offset: 24786},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 736, col: 40, offset: 24790},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 736, col: 43, offset: 24793},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 736, col: 46, offset: 24796},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 736, col: 57, offset: 24807},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 736, col: 60, offset: 24810},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSignExpression",
			pos:  position{line: 737, col: 1, offset: 24894},
			expr: &actionExpr{
				pos: position{line: 737, col: 23, offset: 24916},
				run: (*parser).callonMathSignExpression1,
				expr: &seqExpr{
					pos: position{line: 737, col: 23, offset: 24916},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 737, col: 23, offset: 24916},
							val:        "sign",
							ignoreCase: true,
							want:       "\"SIGN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 737, col: 31, offset: 24924},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 737, col: 34, offset: 24927},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 737, col: 38, offset: 24931},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 737, col: 41, offset: 24934},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 737, col: 44, offset: 24937},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 737, col: 55, offset: 24948},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 737, col: 58, offset: 24951},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSinExpression",
			pos:  position{line: 738, col: 1, offset: 25034},
			expr: &actionExpr{
				pos: position{line: 738, col: 22, offset: 25055},
				run: (*parser).callonMathSinExpression1,
				expr: &seqExpr{
					pos: position{line: 738, col: 22, offset: 25055},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 738, col: 22, offset: 25055},
							val:        "sin",
							ignoreCase: true,
							want:       "\"SIN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 738, col: 29, offset: 25062},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 738, col: 32, offset: 25065},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 738, col: 36, offset: 25069},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 738, col: 39, offset: 25072},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 738, col: 42, offset: 25075},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 738, col: 53, offset: 25086},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 738, col: 56, offset: 25089},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSqrtExpression",
			pos:  position{line: 739, col: 1, offset: 25171},
			expr: &actionExpr{
				pos: position{line: 739, col: 23, offset: 25193},
				run: (*parser).callonMathSqrtExpression1,
				expr: &seqExpr{
					pos: position{line: 739, col: 23, offset: 25193},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 739, col: 23, offset: 25193},
							val:        "sqrt",
							ignoreCase: true,
							want:       "\"SQRT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 739, col: 31, offset: 25201},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 739, col: 34, offset: 25204},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 739, col: 38, offset: 25208},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 739, col: 41, offset: 25211},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 739, col: 44, offset: 25214},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 739, col: 55, offset: 25225},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 739, col: 58, offset: 25228},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSquareExpression",
			pos:  position{line: 740, col: 1, offset: 25311},
			expr: &actionExpr{
				pos: position{line: 740, col: 25, offset: 25335},
				run: (*parser).callonMathSquareExpression1,
				expr: &seqExpr{
					pos: position{line: 740, col: 25, offset: 25335},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 740, col: 25, offset: 25335},
							val:        "square",
							ignoreCase: true,
							want:       "\"SQUARE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 740, col: 35, offset: 25345},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 740, col: 38, offset: 25348},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 740, col: 42, offset: 25352},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 740, col: 45, offset: 25355},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 740, col: 48, offset: 25358},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 740, col: 59, offset: 25369},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 740, col: 62, offset: 25372},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathTanExpression",
			pos:  position{line: 741, col: 1, offset: 25457},
			expr: &actionExpr{
				pos: position{line: 741, col: 22, offset: 25478},
				run: (*parser).callonMathTanExpression1,
				expr: &seqExpr{
					pos: position{line: 741, col: 22, offset: 25478},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 741, col: 22, offset: 25478},
							val:        "tan",
							ignoreCase: true,
							want:       "\"TAN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 741, col: 29, offset: 25485},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 741, col: 32, offset: 25488},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 741, col: 36, offset: 25492},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 741, col: 39, offset: 25495},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 741, col: 42, offset: 25498},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 741, col: 53, offset: 25509},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 741, col: 56, offset: 25512},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathTruncExpression",
			pos:  position{line: 742, col: 1, offset: 25594},
			expr: &actionExpr{
				pos: position{line: 742, col: 24, offset: 25617},
				run: (*parser).callonMathTruncExpression1,
				expr: &seqExpr{
					pos: position{line: 742, col: 24, offset: 25617},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 742, col: 24, offset: 25617},
							val:        "trunc",
							ignoreCase: true,
							want:       "\"TRUNC\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 742, col: 33, offset: 25626},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 742, col: 36, offset: 25629},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 742, col: 40, offset: 25633},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 742, col: 43, offset: 25636},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 742, col: 46, offset: 25639},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 742, col: 57, offset: 25650},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 742, col: 60, offset: 25653},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAtn2Expression",
			pos:  position{line: 744, col: 1, offset: 25738},
			expr: &actionExpr{
				pos: position{line: 744, col: 23, offset: 25760},
				run: (*parser).callonMathAtn2Expression1,
				expr: &seqExpr{
					pos: position{line: 744, col: 23, offset: 25760},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 744, col: 23, offset: 25760},
							val:        "atn2",
							ignoreCase: true,
							want:       "\"ATN2\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 744, col: 31, offset: 25768},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 744, col: 34, offset: 25771},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 744, col: 38, offset: 25775},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 744, col: 41, offset: 25778},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 744, col: 46, offset: 25783},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 744, col: 57, offset: 25794},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 744, col: 60, offset: 25797},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 744, col: 64, offset: 25801},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 744, col: 67, offset: 25804},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 744, col: 72, offset: 25809},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 744, col: 83, offset: 25820},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 744, col: 86, offset: 25823},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntAddExpression",
			pos:  position{line: 745, col: 1, offset: 25914},
			expr: &actionExpr{
				pos: position{line: 745, col: 25, offset: 25938},
				run: (*parser).callonMathIntAddExpression1,
				expr: &seqExpr{
					pos: position{line: 745, col: 25, offset: 25938},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 745, col: 25, offset: 25938},
							val:        "intadd",
							ignoreCase: true,
							want:       "\"IntAdd\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 745, col: 35, offset: 25948},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 745, col: 38, offset: 25951},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 745, col: 42, offset: 25955},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 745, col: 45, offset: 25958},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 745, col: 50, offset: 25963},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 745, col: 61, offset: 25974},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 745, col: 64, offset: 25977},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 745, col: 68, offset: 25981},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 745, col: 71, offset: 25984},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 745, col: 76, offset: 25989},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 745, col: 87, offset: 26000},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 745, col: 90, offset: 26003},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitAndExpression",
			pos:  position{line: 746, col: 1, offset: 26096},
			expr: &actionExpr{
				pos: position{line: 746, col: 28, offset: 26123},
				run: (*parser).callonMathIntBitAndExpression1,
				expr: &seqExpr{
					pos: position{line: 746, col: 28, offset: 26123},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 746, col: 28, offset: 26123},
							val:        "intbitand",
							ignoreCase: true,
							want:       "\"IntBitAnd\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 746, col: 41, offset: 26136},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 746, col: 44, offset: 26139},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 746, col: 48, offset: 26143},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 746, col: 51, offset: 26146},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 746, col: 56, offset: 26151},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 746, col: 67, offset: 26162},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 746, col: 70, offset: 26165},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 746, col: 74, offset: 26169},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 746, col: 77, offset: 26172},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 746, col: 82, offset: 26177},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 746, col: 93, offset: 26188},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 746, col: 96, offset: 26191},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitLeftShiftExpression",
			pos:  position{line: 747, col: 1, offset: 26287},
			expr: &actionExpr{
				pos: position{line: 747, col: 34, offset: 26320},
				run: (*parser).callonMathIntBitLeftShiftExpression1,
				expr: &seqExpr{
					pos: position{line: 747, col: 34, offset: 26320},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 747, col: 34, offset: 26320},
							val:        "intbitleftshift",
							ignoreCase: true,
							want:       "\"IntBitLeftShift\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 747, col: 53, offset: 26339},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 747, col: 56, offset: 26342},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 747, col: 60, offset: 26346},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 747, col: 63, offset: 26349},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 747, col: 68, offset: 26354},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 747, col: 79, offset: 26365},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 747, col: 82, offset: 26368},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 747, col: 86, offset: 26372},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 747, col: 89, offset: 26375},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 747, col: 94, offset: 26380},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 747, col: 105, offset: 26391},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 747, col: 108, offset: 26394},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitOrExpression",
			pos:  position{line: 748, col: 1, offset: 26496},
			expr: &actionExpr{
				pos: position{line: 748, col: 27, offset: 26522},
				run: (*parser).callonMathIntBitOrExpression1,
				expr: &seqExpr{
					pos: position{line: 748, col: 27, offset: 26522},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 748, col: 27, offset: 26522},
							val:        "intbitor",
							ignoreCase: true,
							want:       "\"IntBitOr\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 748, col: 39, offset: 26534},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 748, col: 42, offset: 26537},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 748, col: 46, offset: 26541},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 748, col: 49, offset: 26544},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 748, col: 54, offset: 26549},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 748, col: 65, offset: 26560},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 748, col: 68, offset: 26563},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 748, col: 72, offset: 26567},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 748, col: 75, offset: 26570},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 748, col: 80, offset: 26575},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 748, col: 91, offset: 26586},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 748, col: 94, offset: 26589},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitRightShiftExpression",
			pos:  position{line: 749, col: 1, offset: 26684},
			expr: &actionExpr{
				pos: position{line: 749, col: 35, offset: 26718},
				run: (*parser).callonMathIntBitRightShiftExpression1,
				expr: &seqExpr{
					pos: position{line: 749, col: 35, offset: 26718},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 749, col: 35, offset: 26718},
							val:        "intbitrightshift",
							ignoreCase: true,
							want:       "\"IntBitRightShift\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 749, col: 55, offset: 26738},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 749, col: 58, offset: 26741},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 749, col: 62, offset: 26745},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 749, col: 65, offset: 26748},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 749, col: 70, offset: 26753},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 749, col: 81, offset: 26764},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 749, col: 84, offset: 26767},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 749, col: 88, offset: 26771},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 749, col: 91, offset: 26774},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 749, col: 96, offset: 26779},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 749, col: 107, offset: 26790},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 749, col: 110, offset: 26793},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitXorExpression",
			pos:  position{line: 750, col: 1, offset: 26896},
			expr: &actionExpr{
				pos: position{line: 750, col: 28, offset: 26923},
				run: (*parser).callonMathIntBitXorExpression1,
				expr: &seqExpr{
					pos: position{line: 750, col: 28, offset: 26923},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 750, col: 28, offset: 26923},
							val:        "intbitxor",
							ignoreCase: true,
							want:       "\"IntBitXor\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 750, col: 41, offset: 26936},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 750, col: 44, offset: 26939},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 750, col: 48, offset: 26943},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 750, col: 51, offset: 26946},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 750, col: 56, offset: 26951},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 750, col: 67, offset: 26962},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 750, col: 70, offset: 26965},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 750, col: 74, offset: 26969},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 750, col: 77, offset: 26972},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 750, col: 82, offset: 26977},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 750, col: 93, offset: 26988},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 750, col: 96, offset: 26991},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntDivExpression",
			pos:  position{line: 751, col: 1, offset: 27087},
			expr: &actionExpr{
				pos: position{line: 751, col: 25, offset: 27111},
				run: (*parser).callonMathIntDivExpression1,
				expr: &seqExpr{
					pos: position{line: 751, col: 25, offset: 27111},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 751, col: 25, offset: 27111},
							val:        "intdiv",
							ignoreCase: true,
							want:       "\"IntDiv\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 751, col: 35, offset: 27121},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 751, col: 38, offset: 27124},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 751, col: 42, offset: 27128},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 751, col: 45, offset: 27131},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 751, col: 50, offset: 27136},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 751, col: 61, offset: 27147},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 751, col: 64, offset: 27150},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 751, col: 68, offset: 27154},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 751, col: 71, offset: 27157},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 751, col: 76, offset: 27162},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 751, col: 87, offset: 27173},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 751, col: 90, offset: 27176},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntModExpression",
			pos:  position{line: 752, col: 1, offset: 27269},
			expr: &actionExpr{
				pos: position{line: 752, col: 25, offset: 27293},
				run: (*parser).callonMathIntModExpression1,
				expr: &seqExpr{
					pos: position{line: 752, col: 25, offset: 27293},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 752, col: 25, offset: 27293},
							val:        "intmod",
							ignoreCase: true,
							want:       "\"IntMod\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 752, col: 35, offset: 27303},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 752, col: 38, offset: 27306},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 752, col: 42, offset: 27310},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 752, col: 45, offset: 27313},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 752, col: 50, offset: 27318},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 752, col: 61, offset: 27329},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 752, col: 64, offset: 27332},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 752, col: 68, offset: 27336},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 752, col: 71, offset: 27339},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 752, col: 76, offset: 27344},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 752, col: 87, offset: 27355},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 752, col: 90, offset: 27358},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntMulExpression",
			pos:  position{line: 753, col: 1, offset: 27451},
			expr: &actionExpr{
				pos: position{line: 753, col: 25, offset: 27475},
				run: (*parser).callonMathIntMulExpression1,
				expr: &seqExpr{
					pos: position{line: 753, col: 25, offset: 27475},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 753, col: 25, offset: 27475},
							val:        "intmul",
							ignoreCase: true,
							want:       "\"IntMul\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 753, col: 35, offset: 27485},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 753, col: 38, offset: 27488},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 753, col: 42, offset: 27492},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 753, col: 45, offset: 27495},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 753, col: 50, offset: 27500},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 753, col: 61, offset: 27511},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 753, col: 64, offset: 27514},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 753, col: 68, offset: 27518},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 753, col: 71, offset: 27521},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 753, col: 76, offset: 27526},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 753, col: 87, offset: 27537},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 753, col: 90, offset: 27540},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntSubExpression",
			pos:  position{line: 754, col: 1, offset: 27633},
			expr: &actionExpr{
				pos: position{line: 754, col: 25, offset: 27657},
				run: (*parser).callonMathIntSubExpression1,
				expr: &seqExpr{
					pos: position{line: 754, col: 25, offset: 27657},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 754, col: 25, offset: 27657},
							val:        "intsub",
							ignoreCase: true,
							want:       "\"IntSub\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 754, col: 35, offset: 27667},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 754, col: 38, offset: 27670},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 754, col: 42, offset: 27674},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 754, col: 45, offset: 27677},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 754, col: 50, offset: 27682},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 754, col: 61, offset: 27693},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 754, col: 64, offset: 27696},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 754, col: 68, offset: 27700},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 754, col: 71, offset: 27703},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 754, col: 76, offset: 27708},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 754, col: 87, offset: 27719},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 754, col: 90, offset: 27722},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathPowerExpression",
			pos:  position{line: 755, col: 1, offset: 27815},
			expr: &actionExpr{
				pos: position{line: 755, col: 24, offset: 27838},
				run: (*parser).callonMathPowerExpression1,
				expr: &seqExpr{
					pos: position{line: 755, col: 24, offset: 27838},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 755, col: 24, offset: 27838},
							val:        "power",
							ignoreCase: true,
							want:       "\"POWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 755, col: 33, offset: 27847},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 755, col: 36, offset: 27850},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 755, col: 40, offset: 27854},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 755, col: 43, offset: 27857},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 755, col: 48, offset: 27862},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 755, col: 59, offset: 27873},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 755, col: 62, offset: 27876},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 755, col: 66, offset: 27880},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 755, col: 69, offset: 27883},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 755, col: 74, offset: 27888},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 755, col: 85, offset: 27899},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 755, col: 88, offset: 27902},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathLogExpression",
			pos:  position{line: 757, col: 1, offset: 27995},
			expr: &actionExpr{
				pos: position{line: 757, col: 22, offset: 28016},
				run: (*parser).callonMathLogExpression1,
				expr: &seqExpr{
					pos: position{line: 757, col: 22, offset: 28016},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 757, col: 22, offset: 28016},
							val:        "log",
							ignoreCase: true,
							want:       "\"LOG\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 757, col: 29, offset: 28023},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 757, col: 32, offset: 28026},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 757, col: 36, offset: 28030},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 757, col: 39, offset: 28033},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 757, col: 43, offset: 28037},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 757, col: 54, offset: 28048},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 757, col: 61, offset: 28055},
								expr: &actionExpr{
									pos: position{line: 757, col: 62, offset: 28056},
									run: (*parser).callonMathLogExpression11,
									expr: &seqExpr{
										pos: position{line: 757, col: 62, offset: 28056},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 757, col: 62, offset: 28056},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 757, col: 65, offset: 28059},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 757, col: 69, offset: 28063},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 757, col: 72, offset: 28066},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 757, col: 75, offset: 28069},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 757, col: 107, offset: 28101},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 757, col: 110, offset: 28104},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathNumberBinExpression",
			pos:  position{line: 760, col: 1, offset: 28226},
			expr: &actionExpr{
				pos: position{line: 760, col: 28, offset: 28253},
				run: (*parser).callonMathNumberBinExpression1,
				expr: &seqExpr{
					pos: position{line: 760, col: 28, offset: 28253},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 760, col: 28, offset: 28253},
							val:        "numberbin",
							ignoreCase: true,
							want:       "\"NumberBin\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 760, col: 41, offset: 28266},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 760, col: 44, offset: 28269},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 760, col: 48, offset: 28273},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 760, col: 51, offset: 28276},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 760, col: 55, offset: 28280},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 760, col: 66, offset: 28291},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 760, col: 73, offset: 28298},
								expr: &actionExpr{
									pos: position{line: 760, col: 74, offset: 28299},
									run: (*parser).callonMathNumberBinExpression11,
									expr: &seqExpr{
										pos: position{line: 760, col: 74, offset: 28299},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 760, col: 74, offset: 28299},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 760, col: 77, offset: 28302},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 760, col: 81, offset: 28306},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 760, col: 84, offset: 28309},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 760, col: 87, offset: 28312},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 760, col: 119, offset: 28344},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 760, col: 122, offset: 28347},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathPiExpression",
			pos:  position{line: 763, col: 1, offset: 28475},
			expr: &actionExpr{
				pos: position{line: 763, col: 21, offset: 28495},
				run: (*parser).callonMathPiExpression1,
				expr: &seqExpr{
					pos: position{line: 763, col: 21, offset: 28495},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 763, col: 21, offset: 28495},
							val:        "pi",
							ignoreCase: true,
							want:       "\"PI\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 763, col: 27, offset: 28501},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 763, col: 30, offset: 28504},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 763, col: 34, offset: 28508},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 763, col: 37, offset: 28511},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRandExpression",
			pos:  position{line: 764, col: 1, offset: 28590},
			expr: &actionExpr{
				pos: position{line: 764, col: 23, offset: 28612},
				run: (*parser).callonMathRandExpression1,
				expr: &seqExpr{
					pos: position{line: 764, col: 23, offset: 28612},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 764, col: 23, offset: 28612},
							val:        "rand",
							ignoreCase: true,
							want:       "\"RAND\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 764, col: 31, offset: 28620},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 764, col: 34, offset: 28623},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 764, col: 38, offset: 28627},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 764, col: 41, offset: 28630},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "InFunction",
			pos:  position{line: 766, col: 1, offset: 28712},
			expr: &choiceExpr{
				pos: position{line: 766, col: 15, offset: 28726},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 766, col: 15, offset: 28726},
						run: (*parser).callonInFunction2,
						expr: &seqExpr{
							pos: position{line: 766, col: 15, offset: 28726},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 766, col: 15, offset: 28726},
									label: "ex1",
									expr: &ruleRefExpr{
										pos:  position{line: 766, col: 19, offset: 28730},
										name: "SelectProperty",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 766, col: 34, offset: 28745},
									name: "ws",
								},
								&ruleRefExpr{
									pos:  position{line: 766, col: 37, offset: 28748},
									name: "In",
								},
								&ruleRefExpr{
									pos:  position{line: 766, col: 40, offset: 28751},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 766, col: 43, offset: 28754},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 766, col: 47, offset: 28758},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 766, col: 50, offset: 28761},
									label: "ex2",
									expr: &ruleRefExpr{
										pos:  position{line: 766, col: 54, offset: 28765},
										name: "SelectItem",
									},
								},
								&labeledExpr{
									pos:   position{line: 766, col: 65, offset: 28776},
									label: "others",
									expr: &zeroOrMoreExpr{
										pos: position{line: 766, col: 72, offset: 28783},
										expr: &actionExpr{
											pos: position{line: 766, col: 73, offset: 28784},
											run: (*parser).callonInFunction15,
											expr: &seqExpr{
												pos: position{line: 766, col: 73, offset: 28784},
												exprs: []any{
													&ruleRefExpr{
														pos:  position{line: 766, col: 73, offset: 28784},
														name: "ws",
													},
													&litMatcher{
														pos:        position{line: 766, col: 76, offset: 28787},
														val:        ",",
														ignoreCase: false,
														want:       "\",\"",
													},
													&ruleRefExpr{
														pos:  position{line: 766, col: 80, offset: 28791},
														name: "ws",
													},
													&labeledExpr{
														pos:   position{line: 766, col: 83, offset: 28794},
														label: "ex",
														expr: &ruleRefExpr{
															pos:  position{line: 766, col: 86, offset: 28797},
															name: "SelectItem",
														},
													},
												},
											},
										},
									},
								},
								&ruleRefExpr{
									pos:  position{line: 766, col: 118, offset: 28829},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 766, col: 121, offset: 28832},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 768, col: 5, offset: 28956},
						run: (*parser).callonInFunction24,
						expr: &seqExpr{
							pos: position{line: 768, col: 5, offset: 28956},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 768, col: 5, offset: 28956},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 768, col: 9, offset: 28960},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 768, col: 12, offset: 28963},
									label: "ex1",
									expr: &ruleRefExpr{
										pos:  position{line: 768, col: 16, offset: 28967},
										name: "SelectItem",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 768, col: 27, offset: 28978},
									name: "ws",
								},
								&ruleRefExpr{
									pos:  position{line: 768, col: 30, offset: 28981},
									name: "In",
								},
								&ruleRefExpr{
									pos:  position{line: 768, col: 33, offset: 28984},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 768, col: 36, offset: 28987},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 768, col: 40, offset: 28991},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 768, col: 43, offset: 28994},
									label: "ex2",
									expr: &ruleRefExpr{
										pos:  position{line: 768, col: 47, offset: 28998},
										name: "SelectItem",
									},
								},
								&labeledExpr{
									pos:   position{line: 768, col: 58, offset: 29009},
									label: "others",
									expr: &zeroOrMoreExpr{
										pos: position{line: 768, col: 65, offset: 29016},
										expr: &actionExpr{
											pos: position{line: 768, col: 66, offset: 29017},
											run: (*parser).callonInFunction39,
											expr: &seqExpr{
												pos: position{line: 768, col: 66, offset: 29017},
												exprs: []any{
													&ruleRefExpr{
														pos:  position{line: 768, col: 66, offset: 29017},
														name: "ws",
													},
													&litMatcher{
														pos:        position{line: 768, col: 69, offset: 29020},
														val:        ",",
														ignoreCase: false,
														want:       "\",\"",
													},
													&ruleRefExpr{
														pos:  position{line: 768, col: 73, offset: 29024},
														name: "ws",
													},
													&labeledExpr{
														pos:   position{line: 768, col: 76, offset: 29027},
														label: "ex",
														expr: &ruleRefExpr{
															pos:  position{line: 768, col: 79, offset: 29030},
															name: "SelectItem",
														},
													},
												},
											},
										},
									},
								},
								&ruleRefExpr{
									pos:  position{line: 768, col: 111, offset: 29062},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 768, col: 114, offset: 29065},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
								&ruleRefExpr{
									pos:  position{line: 768, col: 118, offset: 29069},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 768, col: 121, offset: 29072},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AvgAggregateExpression",
			pos:  position{line: 772, col: 1, offset: 29195},
			expr: &actionExpr{
				pos: position{line: 772, col: 29, offset: 29223},
				run: (*parser).callonAvgAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 772, col: 29, offset: 29223},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 772, col: 29, offset: 29223},
							val:        "avg",
							ignoreCase: true,
							want:       "\"AVG\"i",
						},
						&litMatcher{
							pos:        position{line: 772, col: 36, offset: 29230},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 772, col: 40, offset: 29234},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 772, col: 43, offset: 29237},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 772, col: 46, offset: 29240},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 772, col: 58, offset: 29252},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 772, col: 61, offset: 29255},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "CountAggregateExpression",
			pos:  position{line: 776, col: 1, offset: 29347},
			expr: &actionExpr{
				pos: position{line: 776, col: 29, offset: 29375},
				run: (*parser).callonCountAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 776, col: 29, offset: 29375},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 776, col: 29, offset: 29375},
							val:        "count",
							ignoreCase: true,
							want:       "\"COUNT\"i",
						},
						&litMatcher{
							pos:        position{line: 776, col: 38, offset: 29384},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 776, col: 42, offset: 29388},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 776, col: 45, offset: 29391},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 776, col: 48, offset: 29394},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 776, col: 59, offset: 29405},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 776, col: 62, offset: 29408},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MaxAggregateExpression",
			pos:  position{line: 780, col: 1, offset: 29502},
			expr: &actionExpr{
				pos: position{line: 780, col: 29, offset: 29530},
				run: (*parser).callonMaxAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 780, col: 29, offset: 29530},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 780, col: 29, offset: 29530},
							val:        "max",
							ignoreCase: true,
							want:       "\"MAX\"i",
						},
						&litMatcher{
							pos:        position{line: 780, col: 36, offset: 29537},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 780, col: 40, offset: 29541},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 780, col: 43, offset: 29544},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 780, col: 46, offset: 29547},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 780, col: 57, offset: 29558},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 780, col: 60, offset: 29561},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MinAggregateExpression",
			pos:  position{line: 784, col: 1, offset: 29653},
			expr: &actionExpr{
				pos: position{line: 784, col: 29, offset: 29681},
				run: (*parser).callonMinAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 784, col: 29, offset: 29681},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 784, col: 29, offset: 29681},
							val:        "min",
							ignoreCase: true,
							want:       "\"MIN\"i",
						},
						&litMatcher{
							pos:        position{line: 784, col: 36, offset: 29688},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 784, col: 40, offset: 29692},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 784, col: 43, offset: 29695},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 784, col: 46, offset: 29698},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 784, col: 57, offset: 29709},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 784, col: 60, offset: 29712},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SumAggregateExpression",
			pos:  position{line: 788, col: 1, offset: 29804},
			expr: &actionExpr{
				pos: position{line: 788, col: 29, offset: 29832},
				run: (*parser).callonSumAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 788, col: 29, offset: 29832},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 788, col: 29, offset: 29832},
							val:        "sum",
							ignoreCase: true,
							want:       "\"SUM\"i",
						},
						&litMatcher{
							pos:        position{line: 788, col: 36, offset: 29839},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 788, col: 40, offset: 29843},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 788, col: 43, offset: 29846},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 788, col: 46, offset: 29849},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 788, col: 57, offset: 29860},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 788, col: 60, offset: 29863},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "Integer",
			pos:  position{line: 792, col: 1, offset: 29955},
			expr: &actionExpr{
				pos: position{line: 792, col: 12, offset: 29966},
				run: (*parser).callonInteger1,
				expr: &oneOrMoreExpr{
					pos: position{line: 792, col: 12, offset: 29966},
					expr: &charClassMatcher{
						pos:        position{line: 792, col: 12, offset: 29966},
						val:        "[0-9]",
						ranges:     []rune{'0', '9'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name: "StringCharacter",
			pos:  position{line: 796, col: 1, offset: 30018},
			expr: &choiceExpr{
				pos: position{line: 796, col: 20, offset: 30037},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 796, col: 20, offset: 30037},
						run: (*parser).callonStringCharacter2,
						expr: &seqExpr{
							pos: position{line: 796, col: 20, offset: 30037},
							exprs: []any{
								&notExpr{
									pos: position{line: 796, col: 20, offset: 30037},
									expr: &choiceExpr{
										pos: position{line: 796, col: 22, offset: 30039},
										alternatives: []any{
											&litMatcher{
												pos:        position{line: 796, col: 22, offset: 30039},
												val:        "\"",
												ignoreCase: false,
												want:       "\"\\\"\"",
											},
											&litMatcher{
												pos:        position{line: 796, col: 28, offset: 30045},
												val:        "\\",
												ignoreCase: false,
												want:       "\"\\\\\"",
											},
										},
									},
								},
								&anyMatcher{
									line: 796, col: 34, offset: 30051,
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 797, col: 5, offset: 30088},
						run: (*parser).callonStringCharacter9,
						expr: &seqExpr{
							pos: position{line: 797, col: 5, offset: 30088},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 797, col: 5, offset: 30088},
									val:        "\\",
									ignoreCase: false,
									want:       "\"\\\\\"",
								},
								&labeledExpr{
									pos:   position{line: 797, col: 10, offset: 30093},
									label: "seq",
									expr: &ruleRefExpr{
										pos:  position{line: 797, col: 14, offset: 30097},
										name: "EscapeSequenceCharacter",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "EscapeSequenceCharacter",
			pos:  position{line: 799, col: 1, offset: 30142},
			expr: &labeledExpr{
				pos:   position{line: 799, col: 28, offset: 30169},
				label: "char",
				expr: &ruleRefExpr{
					pos:  position{line: 799, col: 33, offset: 30174},
					name: "EscapeCharacter",
				},
			},
		},
		{
			name: "EscapeCharacter",
			pos:  position{line: 801, col: 1, offset: 30191},
			expr: &choiceExpr{
				pos: position{line: 801, col: 20, offset: 30210},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 801, col: 20, offset: 30210},
						val:        "'",
						ignoreCase: false,
						want:       "\"'\"",
					},
					&litMatcher{
						pos:        position{line: 802, col: 5, offset: 30218},
						val:        "\"",
						ignoreCase: false,
						want:       "\"\\\"\"",
					},
					&litMatcher{
						pos:        position{line: 803, col: 5, offset: 30226},
						val:        "\\",
						ignoreCase: false,
						want:       "\"\\\\\"",
					},
					&actionExpr{
						pos: position{line: 804, col: 5, offset: 30235},
						run: (*parser).callonEscapeCharacter5,
						expr: &litMatcher{
							pos:        position{line: 804, col: 5, offset: 30235},
							val:        "b",
							ignoreCase: false,
							want:       "\"b\"",
						},
					},
					&actionExpr{
						pos: position{line: 805, col: 5, offset: 30264},
						run: (*parser).callonEscapeCharacter7,
						expr: &litMatcher{
							pos:        position{line: 805, col: 5, offset: 30264},
							val:        "f",
							ignoreCase: false,
							want:       "\"f\"",
						},
					},
					&actionExpr{
						pos: position{line: 806, col: 5, offset: 30293},
						run: (*parser).callonEscapeCharacter9,
						expr: &litMatcher{
							pos:        position{line: 806, col: 5, offset: 30293},
							val:        "n",
							ignoreCase: false,
							want:       "\"n\"",
						},
					},
					&actionExpr{
						pos: position{line: 807, col: 5, offset: 30322},
						run: (*parser).callonEscapeCharacter11,
						expr: &litMatcher{
							pos:        position{line: 807, col: 5, offset: 30322},
							val:        "r",
							ignoreCase: false,
							want:       "\"r\"",
						},
					},
					&actionExpr{
						pos: position{line: 808, col: 5, offset: 30351},
						run: (*parser).callonEscapeCharacter13,
						expr: &litMatcher{
							pos:        position{line: 808, col: 5, offset: 30351},
							val:        "t",
							ignoreCase: false,
							want:       "\"t\"",
						},
					},
				},
			},
		},
		{
			name: "non_escape_character",
			pos:  position{line: 810, col: 1, offset: 30377},
			expr: &actionExpr{
				pos: position{line: 810, col: 25, offset: 30401},
				run: (*parser).callonnon_escape_character1,
				expr: &seqExpr{
					pos: position{line: 810, col: 25, offset: 30401},
					exprs: []any{
						&notExpr{
							pos: position{line: 810, col: 25, offset: 30401},
							expr: &ruleRefExpr{
								pos:  position{line: 810, col: 27, offset: 30403},
								name: "escape_character",
							},
						},
						&labeledExpr{
							pos:   position{line: 810, col: 45, offset: 30421},
							label: "char",
							expr: &anyMatcher{
								line: 810, col: 50, offset: 30426,
							},
						},
					},
				},
			},
		},
		{
			name: "ws",
			pos:  position{line: 813, col: 1, offset: 30465},
			expr: &zeroOrMoreExpr{
				pos: position{line: 813, col: 7, offset: 30471},
				expr: &charClassMatcher{
					pos:        position{line: 813, col: 7, offset: 30471},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "wss",
			pos:  position{line: 815, col: 1, offset: 30483},
			expr: &oneOrMoreExpr{
				pos: position{line: 815, col: 8, offset: 30490},
				expr: &charClassMatcher{
					pos:        position{line: 815, col: 8, offset: 30490},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "EOF",
			pos:  position{line: 817, col: 1, offset: 30502},
			expr: &notExpr{
				pos: position{line: 817, col: 8, offset: 30509},
				expr: &anyMatcher{
					line: 817, col: 9, offset: 30510,
				},
			},
		},
	},
}

func (c *current) onInput1(selectStmt any) (any, error) {
	return selectStmt, nil
}

func (p *parser) callonInput1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInput1(stack["selectStmt"])
}

func (c *current) onSelectStmt22(join any) (any, error) {
	return join, nil
}

func (p *parser) callonSelectStmt22() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt22(stack["join"])
}

func (c *current) onSelectStmt30(condition any) (any, error) {
	return condition, nil
}

func (p *parser) callonSelectStmt30() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt30(stack["condition"])
}

func (c *current) onSelectStmt39(columns any) (any, error) {
	return columns, nil
}

func (p *parser) callonSelectStmt39() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt39(stack["columns"])
}

func (c *current) onSelectStmt48(order any) (any, error) {
	return order, nil
}

func (p *parser) callonSelectStmt48() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt48(stack["order"])
}

func (c *current) onSelectStmt55(offset any) (any, error) {
	return offset, nil
}

func (p *parser) callonSelectStmt55() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt55(stack["offset"])
}

func (c *current) onSelectStmt1(distinctClause, topClause, columns, fromClause, joinClauses, whereClause, groupByClause, orderByClause, offsetClause any) (any, error) {
	return makeSelectStmt(columns, fromClause, joinClauses, whereClause,
		distinctClause, topClause, groupByClause, orderByClause, offsetClause)
}

func (p *parser) callonSelectStmt1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt1(stack["distinctClause"], stack["topClause"], stack["columns"], stack["fromClause"], stack["joinClauses"], stack["whereClause"], stack["groupByClause"], stack["orderByClause"], stack["offsetClause"])
}

func (c *current) onTopClause1(count any) (any, error) {
	return count, nil
}

func (p *parser) callonTopClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTopClause1(stack["count"])
}

func (c *current) onFromClause9(column any) (any, error) {
	return column, nil
}

func (p *parser) callonFromClause9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause9(stack["column"])
}

func (c *current) onFromClause2(table, selectItem any) (any, error) {
	tableTyped := table.(parsers.Table)

	if selectItem != nil {
		tableTyped.SelectItem = selectItem.(parsers.SelectItem)
		tableTyped.IsInSelect = true
	}

	return tableTyped, nil
}

func (p *parser) callonFromClause2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause2(stack["table"], stack["selectItem"])
}

func (c *current) onFromClause16(column any) (any, error) {
	tableSelectItem := column.(parsers.SelectItem)
	table := parsers.Table{
		Value:      tableSelectItem.Alias,
		SelectItem: tableSelectItem,
	}
	return table, nil
}

func (p *parser) callonFromClause16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause16(stack["column"])
}

func (c *current) onFromClause22(subQuery any) (any, error) {
	subQueryTyped := subQuery.(parsers.SelectItem)
	table := parsers.Table{
		Value:      subQueryTyped.Alias,
		SelectItem: subQueryTyped,
	}
	return table, nil
}

func (p *parser) callonFromClause22() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause22(stack["subQuery"])
}

func (c *current) onSubQuery5(exists any) (any, error) {
	return exists, nil
}

func (p *parser) callonSubQuery5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuery5(stack["exists"])
}

func (c *current) onSubQuery1(exists, selectStmt any) (any, error) {
	if selectStatement, isGoodValue := selectStmt.(parsers.SelectStmt); isGoodValue {
		selectStatement.Exists = exists != nil
		return selectStatement, nil
	}

	return selectStmt, nil
}

func (p *parser) callonSubQuery1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuery1(stack["exists"], stack["selectStmt"])
}

func (c *current) onSubQuerySelectItem7(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonSubQuerySelectItem7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuerySelectItem7(stack["alias"])
}

func (c *current) onSubQuerySelectItem1(subQuery, asClause any) (any, error) {
	selectItem := parsers.SelectItem{
		Type:  parsers.SelectItemTypeSubQuery,
		Value: subQuery,
	}

	if tableName, isString := asClause.(string); isString {
		selectItem.Alias = tableName
	}

	return selectItem, nil
}

func (p *parser) callonSubQuerySelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuerySelectItem1(stack["subQuery"], stack["asClause"])
}

func (c *current) onJoinClause2(table, column any) (any, error) {
	return makeJoin(table, column)
}

func (p *parser) callonJoinClause2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onJoinClause2(stack["table"], stack["column"])
}

func (c *current) onJoinClause13(subQuery any) (any, error) {
	return makeJoin(nil, subQuery)
}

func (p *parser) callonJoinClause13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onJoinClause13(stack["subQuery"])
}

func (c *current) onOffsetClause1(offset, limit any) (any, error) {
	return []interface{}{offset.(parsers.Constant).Value, limit.(parsers.Constant).Value}, nil
}

func (p *parser) callonOffsetClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOffsetClause1(stack["offset"], stack["limit"])
}

func (c *current) onSelectAsterisk1() (any, error) {
	selectItem, _ := makeSelectItem("c", make([]interface{}, 0), parsers.SelectItemTypeField)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectAsterisk1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectAsterisk1()
}

func (c *current) onColumnList7(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonColumnList7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList7(stack["coll"])
}

func (c *current) onColumnList1(column, other_columns any) (any, error) {
	return makeColumnList(column, other_columns)
}

func (p *parser) callonColumnList1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList1(stack["column"], stack["other_columns"])
}

func (c *current) onExpressionOrSelectItem2(expression, asClause any) (any, error) {
	switch typedValue := expression.(type) {
	case parsers.ComparisonExpression, parsers.LogicalExpression:
		selectItem := parsers.SelectItem{
			Type:  parsers.SelectItemTypeExpression,
			Value: typedValue,
		}

		if aliasValue, ok := asClause.(string); ok {
			selectItem.Alias = aliasValue
		}

		return selectItem, nil
	case parsers.SelectItem:
		if aliasValue, ok := asClause.(string); ok {
			typedValue.Alias = aliasValue
		}
		return typedValue, nil
	default:
		return typedValue, nil
	}
}

func (p *parser) callonExpressionOrSelectItem2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onExpressionOrSelectItem2(stack["expression"], stack["asClause"])
}

func (c *current) onExpressionOrSelectItem9(item any) (any, error) {
	return item, nil
}

func (p *parser) callonExpressionOrSelectItem9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onExpressionOrSelectItem9(stack["item"])
}

func (c *current) onSelectValueSpec1(column any) (any, error) {
	selectItem := column.(parsers.SelectItem)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectValueSpec1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectValueSpec1(stack["column"])
}

func (c *current) onTableName1(key any) (any, error) {
	return parsers.Table{Value: key.(string)}, nil
}

func (p *parser) callonTableName1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTableName1(stack["key"])
}

func (c *current) onSelectArray1(columns any) (any, error) {
	return makeSelectArray(columns)
}

func (p *parser) callonSelectArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectArray1(stack["columns"])
}

func (c *current) onSelectObject11(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonSelectObject11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject11(stack["coll"])
}

func (c *current) onSelectObject2(field, other_fields any) (any, error) {
	return makeSelectObject(field, other_fields)
}

func (p *parser) callonSelectObject2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject2(stack["field"], stack["other_fields"])
}

func (c *current) onSelectObject20() (any, error) {
	return parsers.SelectItem{
		SelectItems: []parsers.SelectItem{},
		Type:        parsers.SelectItemTypeObject,
	}, nil
}

func (p *parser) callonSelectObject20() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject20()
}

func (c *current) onSelectObjectField6(key any) (any, error) {
	return key, nil
}

func (p *parser) callonSelectObjectField6() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField6(stack["key"])
}

func (c *current) onSelectObjectField1(name, selectItem any) (any, error) {
	item := selectItem.(parsers.SelectItem)
	item.Alias = name.(string)
	return item, nil
}

func (p *parser) callonSelectObjectField1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField1(stack["name"], stack["selectItem"])
}

func (c *current) onSelectProperty1(name, path any) (any, error) {
	return makeSelectItem(name, path, parsers.SelectItemTypeField)
}

func (p *parser) callonSelectProperty1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectProperty1(stack["name"], stack["path"])
}

func (c *current) onSelectItemWithAlias1(selectItem, asClause any) (any, error) {
	item := selectItem.(parsers.SelectItem)
	if aliasValue, ok := asClause.(string); ok {
		item.Alias = aliasValue
	}
	return item, nil
}

func (p *parser) callonSelectItemWithAlias1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectItemWithAlias1(stack["selectItem"], stack["asClause"])
}

func (c *current) onSelectItem1(selectItem any) (any, error) {
	var itemResult parsers.SelectItem
	switch typedValue := selectItem.(type) {
	case parsers.SelectItem:
		itemResult = typedValue
	case parsers.Constant:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeConstant,
			Value: typedValue,
		}
	case parsers.FunctionCall:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeFunctionCall,
			Value: typedValue,
		}
	}

	return itemResult, nil
}

func (p *parser) callonSelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectItem1(stack["selectItem"])
}

func (c *current) onAsClause1(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonAsClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAsClause1(stack["alias"])
}

func (c *current) onDotFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonDotFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDotFieldAccess1(stack["id"])
}

func (c *current) onArrayFieldAccess2(id any) (any, error) {
	return id, nil
}

func (p *parser) callonArrayFieldAccess2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess2(stack["id"])
}

func (c *current) onArrayFieldAccess8(id any) (any, error) {
	return strconv.Itoa(id.(int)), nil
}

func (p *parser) callonArrayFieldAccess8() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess8(stack["id"])
}

func (c *current) onArrayFieldAccess14(id any) (any, error) {
	return id.(parsers.Constant).Value.(string), nil
}

func (p *parser) callonArrayFieldAccess14() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess14(stack["id"])
}

func (c *current) onIdentifier1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonIdentifier1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIdentifier1()
}

func (c *current) onCondition1(expression any) (any, error) {
	return expression, nil
}

func (p *parser) callonCondition1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCondition1(stack["expression"])
}

func (c *current) onOrExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression7(stack["ex"])
}

func (c *current) onOrExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeOr)
}

func (p *parser) callonOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onAndExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonAndExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression7(stack["ex"])
}

func (c *current) onAndExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeAnd)
}

func (p *parser) callonAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onComparisonExpression2(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression2(stack["ex"])
}

func (c *current) onComparisonExpression10(left, op, right any) (any, error) {
	return parsers.ComparisonExpression{Left: left, Right: right, Operation: op.(string)}, nil
}

func (p *parser) callonComparisonExpression10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression10(stack["left"], stack["op"], stack["right"])
}

func (c *current) onComparisonExpression20(inv, ex any) (any, error) {
	if inv != nil {
		ex1 := ex.(parsers.SelectItem)
		ex1.Invert = true
		return ex1, nil
	}
	return ex, nil
}

func (p *parser) callonComparisonExpression20() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression20(stack["inv"], stack["ex"])
}

func (c *current) onComparisonExpression29(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression29() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression29(stack["ex"])
}

func (c *current) onOrderByClause9(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrderByClause9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause9(stack["ex"])
}

func (c *current) onOrderByClause1(ex1, others any) (any, error) {
	return makeOrderByClause(ex1, others)
}

func (p *parser) callonOrderByClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause1(stack["ex1"], stack["others"])
}

func (c *current) onOrderExpression1(field, order any) (any, error) {
	return makeOrderExpression(field, order)
}

func (p *parser) callonOrderExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderExpression1(stack["field"], stack["order"])
}

func (c *current) onOrderDirection1() (any, error) {
	if strings.EqualFold(string(c.text), "DESC") {
		return parsers.OrderDirectionDesc, nil
	}

	return parsers.OrderDirectionAsc, nil
}

func (p *parser) callonOrderDirection1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderDirection1()
}

func (c *current) onComparisonOperator1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonComparisonOperator1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonOperator1()
}

func (c *current) onParameterConstant1() (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeParameterConstant, Value: string(c.text)}, nil
}

func (p *parser) callonParameterConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onParameterConstant1()
}

func (c *current) onNullConstant1() (any, error) {
	return parsers.Constant{Value: nil}, nil
}

func (p *parser) callonNullConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onNullConstant1()
}

func (c *current) onIntegerLiteral1(number any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeInteger, Value: number.(int)}, nil
}

func (p *parser) callonIntegerLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIntegerLiteral1(stack["number"])
}

func (c *current) onStringLiteral1(chars any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeString, Value: joinStrings(chars.([]interface{}))}, nil
}

func (p *parser) callonStringLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringLiteral1(stack["chars"])
}

func (c *current) onFloatLiteral1() (any, error) {
	floatValue, _ := strconv.ParseFloat(string(c.text), 64)
	return parsers.Constant{Type: parsers.ConstantTypeFloat, Value: floatValue}, nil
}

func (p *parser) callonFloatLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFloatLiteral1()
}

func (c *current) onBooleanLiteral1() (any, error) {
	boolValue, _ := strconv.ParseBool(string(c.text))
	return parsers.Constant{Type: parsers.ConstantTypeBoolean, Value: boolValue}, nil
}

func (p *parser) callonBooleanLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onBooleanLiteral1()
}

func (c *current) onUpperExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallUpper, []interface{}{ex})
}

func (p *parser) callonUpperExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onUpperExpression1(stack["ex"])
}

func (c *current) onLowerExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLower, []interface{}{ex})
}

func (p *parser) callonLowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLowerExpression1(stack["ex"])
}

func (c *current) onStringEqualsExpression17(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonStringEqualsExpression17() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression17(stack["boolean"])
}

func (c *current) onStringEqualsExpression1(ex1, ex2, ignoreCase any) (any, error) {
	return createFunctionCall(parsers.FunctionCallStringEquals, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonStringEqualsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression1(stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onToStringExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallToString, []interface{}{ex})
}

func (p *parser) callonToStringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onToStringExpression1(stack["ex"])
}

func (c *current) onConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression11(stack["ex"])
}

func (c *current) onConcatExpression1(ex1, others any) (any, error) {
	arguments := append([]interface{}{ex1}, others.([]interface{})...)
	return createFunctionCall(parsers.FunctionCallConcat, arguments)
}

func (p *parser) callonConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression1(stack["ex1"], stack["others"])
}

func (c *current) onLeftExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLeft, []interface{}{ex, length})
}

func (p *parser) callonLeftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLeftExpression1(stack["ex"], stack["length"])
}

func (c *current) onLengthExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLength, []interface{}{ex})
}

func (p *parser) callonLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLengthExpression1(stack["ex"])
}

func (c *current) onLTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLTrim, []interface{}{ex})
}

func (p *parser) callonLTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLTrimExpression1(stack["ex"])
}

func (c *current) onReplaceExpression1(ex1, ex2, ex3 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplace, []interface{}{ex1, ex2, ex3})
}

func (p *parser) callonReplaceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplaceExpression1(stack["ex1"], stack["ex2"], stack["ex3"])
}

func (c *current) onReplicateExpression1(ex1, ex2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplicate, []interface{}{ex1, ex2})
}

func (p *parser) callonReplicateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplicateExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onReverseExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReverse, []interface{}{ex})
}

func (p *parser) callonReverseExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReverseExpression1(stack["ex"])
}

func (c *current) onRightExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRight, []interface{}{ex, length})
}

func (p *parser) callonRightExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRightExpression1(stack["ex"], stack["length"])
}

func (c *current) onRTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRTrim, []interface{}{ex})
}

func (p *parser) callonRTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRTrimExpression1(stack["ex"])
}

func (c *current) onSubstringExpression1(ex, startPos, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSubstring, []interface{}{ex, startPos, length})
}

func (p *parser) callonSubstringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubstringExpression1(stack["ex"], stack["startPos"], stack["length"])
}

func (c *current) onTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallTrim, []interface{}{ex})
}

func (p *parser) callonTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTrimExpression1(stack["ex"])
}

func (c *current) onThreeArgumentStringFunctionExpression18(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonThreeArgumentStringFunctionExpression18() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression18(stack["boolean"])
}

func (c *current) onThreeArgumentStringFunctionExpression1(function, ex1, ex2, ignoreCase any) (any, error) {
	var functionType parsers.FunctionCallType

	lowerFunction := strings.ToUpper(function.(string))
	switch lowerFunction {
	case "CONTAINS":
		functionType = parsers.FunctionCallContains
	case "ENDSWITH":
		functionType = parsers.FunctionCallEndsWith
	case "STARTSWITH":
		functionType = parsers.FunctionCallStartsWith
	case "INDEX_OF":
		functionType = parsers.FunctionCallIndexOf
	}

	return createFunctionCall(functionType, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonThreeArgumentStringFunctionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression1(stack["function"], stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onThreeArgumentStringFunction1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonThreeArgumentStringFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunction1()
}

func (c *current) onIsDefined1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsDefined, []interface{}{ex})
}

func (p *parser) callonIsDefined1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsDefined1(stack["ex"])
}

func (c *current) onIsArray1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsArray, []interface{}{ex})
}

func (p *parser) callonIsArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsArray1(stack["ex"])
}

func (c *current) onIsBool1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsBool, []interface{}{ex})
}

func (p *parser) callonIsBool1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsBool1(stack["ex"])
}

func (c *current) onIsFiniteNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsFiniteNumber, []interface{}{ex})
}

func (p *parser) callonIsFiniteNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsFiniteNumber1(stack["ex"])
}

func (c *current) onIsInteger1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsInteger, []interface{}{ex})
}

func (p *parser) callonIsInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsInteger1(stack["ex"])
}

func (c *current) onIsNull1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNull, []interface{}{ex})
}

func (p *parser) callonIsNull1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNull1(stack["ex"])
}

func (c *current) onIsNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNumber, []interface{}{ex})
}

func (p *parser) callonIsNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNumber1(stack["ex"])
}

func (c *current) onIsObject1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsObject, []interface{}{ex})
}

func (p *parser) callonIsObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsObject1(stack["ex"])
}

func (c *current) onIsPrimitive1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsPrimitive, []interface{}{ex})
}

func (p *parser) callonIsPrimitive1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsPrimitive1(stack["ex"])
}

func (c *current) onIsString1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsString, []interface{}{ex})
}

func (p *parser) callonIsString1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsString1(stack["ex"])
}

func (c *current) onArrayConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression11(stack["ex"])
}

func (c *current) onArrayConcatExpression1(arrays, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayConcat, append([]interface{}{arrays}, others.([]interface{})...))
}

func (p *parser) callonArrayConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression1(stack["arrays"], stack["others"])
}

func (c *current) onArrayContainsExpression16(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayContainsExpression16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsExpression16(stack["ex"])
}

func (c *current) onArrayContainsExpression1(array, item, partialMatch any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayContains, []interface{}{array, item, partialMatch})
}

func (p *parser) callonArrayContainsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsExpression1(stack["array"], stack["item"], stack["partialMatch"])
}

func (c *current) onArrayContainsAnyExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayContainsAnyExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAnyExpression11(stack["ex"])
}

func (c *current) onArrayContainsAnyExpression1(array, items any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayContainsAny, append([]interface{}{array}, items.([]interface{})...))
}

func (p *parser) callonArrayContainsAnyExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAnyExpression1(stack["array"], stack["items"])
}

func (c *current) onArrayContainsAllExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayContainsAllExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAllExpression11(stack["ex"])
}

func (c *current) onArrayContainsAllExpression1(array, items any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayContainsAll, append([]interface{}{array}, items.([]interface{})...))
}

func (p *parser) callonArrayContainsAllExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAllExpression1(stack["array"], stack["items"])
}

func (c *current) onArrayLengthExpression1(array any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayLength, []interface{}{array})
}

func (p *parser) callonArrayLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayLengthExpression1(stack["array"])
}

func (c *current) onArraySliceExpression16(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArraySliceExpression16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression16(stack["ex"])
}

func (c *current) onArraySliceExpression1(array, start, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArraySlice, []interface{}{array, start, length})
}

func (p *parser) callonArraySliceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression1(stack["array"], stack["start"], stack["length"])
}

func (c *current) onSetIntersectExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetIntersect, []interface{}{set1, set2})
}

func (p *parser) callonSetIntersectExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetIntersectExpression1(stack["set1"], stack["set2"])
}

func (c *current) onSetUnionExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetUnion, []interface{}{set1, set2})
}

func (p *parser) callonSetUnionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetUnionExpression1(stack["set1"], stack["set2"])
}

func (c *current) onIifExpression1(condition, trueValue, falseValue any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIif, []interface{}{condition, trueValue, falseValue})
}

func (p *parser) callonIifExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIifExpression1(stack["condition"], stack["trueValue"], stack["falseValue"])
}

func (c *current) onMathAbsExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAbs, []interface{}{ex})
}

func (p *parser) callonMathAbsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAbsExpression1(stack["ex"])
}

func (c *current) onMathAcosExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAcos, []interface{}{ex})
}

func (p *parser) callonMathAcosExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAcosExpression1(stack["ex"])
}

func (c *current) onMathAsinExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAsin, []interface{}{ex})
}

func (p *parser) callonMathAsinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAsinExpression1(stack["ex"])
}

func (c *current) onMathAtanExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAtan, []interface{}{ex})
}

func (p *parser) callonMathAtanExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAtanExpression1(stack["ex"])
}

func (c *current) onMathCeilingExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCeiling, []interface{}{ex})
}

func (p *parser) callonMathCeilingExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCeilingExpression1(stack["ex"])
}

func (c *current) onMathCosExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCos, []interface{}{ex})
}

func (p *parser) callonMathCosExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCosExpression1(stack["ex"])
}

func (c *current) onMathCotExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCot, []interface{}{ex})
}

func (p *parser) callonMathCotExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCotExpression1(stack["ex"])
}

func (c *current) onMathDegreesExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathDegrees, []interface{}{ex})
}

func (p *parser) callonMathDegreesExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathDegreesExpression1(stack["ex"])
}

func (c *current) onMathExpExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathExp, []interface{}{ex})
}

func (p *parser) callonMathExpExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathExpExpression1(stack["ex"])
}

func (c *current) onMathFloorExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathFloor, []interface{}{ex})
}

func (p *parser) callonMathFloorExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathFloorExpression1(stack["ex"])
}

func (c *current) onMathIntBitNotExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitNot, []interface{}{ex})
}

func (p *parser) callonMathIntBitNotExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitNotExpression1(stack["ex"])
}

func (c *current) onMathLog10Expression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathLog10, []interface{}{ex})
}

func (p *parser) callonMathLog10Expression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLog10Expression1(stack["ex"])
}

func (c *current) onMathRadiansExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRadians, []interface{}{ex})
}

func (p *parser) callonMathRadiansExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRadiansExpression1(stack["ex"])
}

func (c *current) onMathRoundExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRound, []interface{}{ex})
}

func (p *parser) callonMathRoundExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRoundExpression1(stack["ex"])
}

func (c *current) onMathSignExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSign, []interface{}{ex})
}

func (p *parser) callonMathSignExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSignExpression1(stack["ex"])
}

func (c *current) onMathSinExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSin, []interface{}{ex})
}

func (p *parser) callonMathSinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSinExpression1(stack["ex"])
}

func (c *current) onMathSqrtExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSqrt, []interface{}{ex})
}

func (p *parser) callonMathSqrtExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSqrtExpression1(stack["ex"])
}

func (c *current) onMathSquareExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSquare, []interface{}{ex})
}

func (p *parser) callonMathSquareExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSquareExpression1(stack["ex"])
}

func (c *current) onMathTanExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathTan, []interface{}{ex})
}

func (p *parser) callonMathTanExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathTanExpression1(stack["ex"])
}

func (c *current) onMathTruncExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathTrunc, []interface{}{ex})
}

func (p *parser) callonMathTruncExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathTruncExpression1(stack["ex"])
}

func (c *current) onMathAtn2Expression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAtn2, []interface{}{set1, set2})
}

func (p *parser) callonMathAtn2Expression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAtn2Expression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntAddExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntAdd, []interface{}{set1, set2})
}

func (p *parser) callonMathIntAddExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntAddExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitAndExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitAnd, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitAndExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitLeftShiftExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitLeftShift, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitLeftShiftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitLeftShiftExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitOrExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitOr, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitOrExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitRightShiftExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitRightShift, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitRightShiftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitRightShiftExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitXorExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitXor, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitXorExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitXorExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntDivExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntDiv, []interface{}{set1, set2})
}

func (p *parser) callonMathIntDivExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntDivExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntModExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntMod, []interface{}{set1, set2})
}

func (p *parser) callonMathIntModExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntModExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntMulExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntMul, []interface{}{set1, set2})
}

func (p *parser) callonMathIntMulExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntMulExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntSubExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntSub, []interface{}{set1, set2})
}

func (p *parser) callonMathIntSubExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntSubExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathPowerExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathPower, []interface{}{set1, set2})
}

func (p *parser) callonMathPowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathPowerExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathLogExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonMathLogExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLogExpression11(stack["ex"])
}

func (c *current) onMathLogExpression1(ex1, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathLog, append([]interface{}{ex1}, others.([]interface{})...))
}

func (p *parser) callonMathLogExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLogExpression1(stack["ex1"], stack["others"])
}

func (c *current) onMathNumberBinExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonMathNumberBinExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathNumberBinExpression11(stack["ex"])
}

func (c *current) onMathNumberBinExpression1(ex1, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathNumberBin, append([]interface{}{ex1}, others.([]interface{})...))
}

func (p *parser) callonMathNumberBinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathNumberBinExpression1(stack["ex1"], stack["others"])
}

func (c *current) onMathPiExpression1() (any, error) {
	return createFunctionCall(parsers.FunctionCallMathPi, []interface{}{})
}

func (p *parser) callonMathPiExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathPiExpression1()
}

func (c *current) onMathRandExpression1() (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRand, []interface{}{})
}

func (p *parser) callonMathRandExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRandExpression1()
}

func (c *current) onInFunction15(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonInFunction15() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction15(stack["ex"])
}

func (c *current) onInFunction2(ex1, ex2, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIn, append([]interface{}{ex1, ex2}, others.([]interface{})...))
}

func (p *parser) callonInFunction2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction2(stack["ex1"], stack["ex2"], stack["others"])
}

func (c *current) onInFunction39(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonInFunction39() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction39(stack["ex"])
}

func (c *current) onInFunction24(ex1, ex2, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIn, append([]interface{}{ex1, ex2}, others.([]interface{})...))
}

func (p *parser) callonInFunction24() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction24(stack["ex1"], stack["ex2"], stack["others"])
}

func (c *current) onAvgAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateAvg, []interface{}{ex})
}

func (p *parser) callonAvgAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAvgAggregateExpression1(stack["ex"])
}

func (c *current) onCountAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateCount, []interface{}{ex})
}

func (p *parser) callonCountAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCountAggregateExpression1(stack["ex"])
}

func (c *current) onMaxAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateMax, []interface{}{ex})
}

func (p *parser) callonMaxAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMaxAggregateExpression1(stack["ex"])
}

func (c *current) onMinAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateMin, []interface{}{ex})
}

func (p *parser) callonMinAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMinAggregateExpression1(stack["ex"])
}

func (c *current) onSumAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateSum, []interface{}{ex})
}

func (p *parser) callonSumAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSumAggregateExpression1(stack["ex"])
}

func (c *current) onInteger1() (any, error) {
	return strconv.Atoi(string(c.text))
}

func (p *parser) callonInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInteger1()
}

func (c *current) onStringCharacter2() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonStringCharacter2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter2()
}

func (c *current) onStringCharacter9(seq any) (any, error) {
	return seq, nil
}

func (p *parser) callonStringCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter9(stack["seq"])
}

func (c *current) onEscapeCharacter5() (any, error) {
	return "\b", nil
}

func (p *parser) callonEscapeCharacter5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter5()
}

func (c *current) onEscapeCharacter7() (any, error) {
	return "\f", nil
}

func (p *parser) callonEscapeCharacter7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter7()
}

func (c *current) onEscapeCharacter9() (any, error) {
	return "\n", nil
}

func (p *parser) callonEscapeCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter9()
}

func (c *current) onEscapeCharacter11() (any, error) {
	return "\r", nil
}

func (p *parser) callonEscapeCharacter11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter11()
}

func (c *current) onEscapeCharacter13() (any, error) {
	return "\t", nil
}

func (p *parser) callonEscapeCharacter13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter13()
}

func (c *current) onnon_escape_character1(char any) (any, error) {
	return string(c.text), nil
}

func (p *parser) callonnon_escape_character1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onnon_escape_character1(stack["char"])
}

var (
	// errNoRule is returned when the grammar to parse has no rule.
	errNoRule = errors.New("grammar has no rule")

	// errInvalidEntrypoint is returned when the specified entrypoint rule
	// does not exit.
	errInvalidEntrypoint = errors.New("invalid entrypoint")

	// errInvalidEncoding is returned when the source is not properly
	// utf8-encoded.
	errInvalidEncoding = errors.New("invalid encoding")

	// errMaxExprCnt is used to signal that the maximum number of
	// expressions have been parsed.
	errMaxExprCnt = errors.New("max number of expressions parsed")
)

// Option is a function that can set an option on the parser. It returns
// the previous setting as an Option.
type Option func(*parser) Option

// MaxExpressions creates an Option to stop parsing after the provided
// number of expressions have been parsed, if the value is 0 then the parser will
// parse for as many steps as needed (possibly an infinite number).
//
// The default for maxExprCnt is 0.
func MaxExpressions(maxExprCnt uint64) Option {
	return func(p *parser) Option {
		oldMaxExprCnt := p.maxExprCnt
		p.maxExprCnt = maxExprCnt
		return MaxExpressions(oldMaxExprCnt)
	}
}

// Entrypoint creates an Option to set the rule name to use as entrypoint.
// The rule name must have been specified in the -alternate-entrypoints
// if generating the parser with the -optimize-grammar flag, otherwise
// it may have been optimized out. Passing an empty string sets the
// entrypoint to the first rule in the grammar.
//
// The default is to start parsing at the first rule in the grammar.
func Entrypoint(ruleName string) Option {
	return func(p *parser) Option {
		oldEntrypoint := p.entrypoint
		p.entrypoint = ruleName
		if ruleName == "" {
			p.entrypoint = g.rules[0].name
		}
		return Entrypoint(oldEntrypoint)
	}
}

// Statistics adds a user provided Stats struct to the parser to allow
// the user to process the results after the parsing has finished.
// Also the key for the "no match" counter is set.
//
// Example usage:
//
//	input := "input"
//	stats := Stats{}
//	_, err := Parse("input-file", []byte(input), Statistics(&stats, "no match"))
//	if err != nil {
//	    log.Panicln(err)
//	}
//	b, err := json.MarshalIndent(stats.ChoiceAltCnt, "", "  ")
//	if err != nil {
//	    log.Panicln(err)
//	}
//	fmt.Println(string(b))
func Statistics(stats *Stats, choiceNoMatch string) Option {
	return func(p *parser) Option {
		oldStats := p.Stats
		p.Stats = stats
		oldChoiceNoMatch := p.choiceNoMatch
		p.choiceNoMatch = choiceNoMatch
		if p.Stats.ChoiceAltCnt == nil {
			p.Stats.ChoiceAltCnt = make(map[string]map[string]int)
		}
		return Statistics(oldStats, oldChoiceNoMatch)
	}
}

// Debug creates an Option to set the debug flag to b. When set to true,
// debugging information is printed to stdout while parsing.
//
// The default is false.
func Debug(b bool) Option {
	return func(p *parser) Option {
		old := p.debug
		p.debug = b
		return Debug(old)
	}
}

// Memoize creates an Option to set the memoize flag to b. When set to true,
// the parser will cache all results so each expression is evaluated only
// once. This guarantees linear parsing time even for pathological cases,
// at the expense of more memory and slower times for typical cases.
//
// The default is false.
func Memoize(b bool) Option {
	return func(p *parser) Option {
		old := p.memoize
		p.memoize = b
		return Memoize(old)
	}
}

// AllowInvalidUTF8 creates an Option to allow invalid UTF-8 bytes.
// Every invalid UTF-8 byte is treated as a utf8.RuneError (U+FFFD)
// by character class matchers and is matched by the any matcher.
// The returned matched value, c.text and c.offset are NOT affected.
//
// The default is false.
func AllowInvalidUTF8(b bool) Option {
	return func(p *parser) Option {
		old := p.allowInvalidUTF8
		p.allowInvalidUTF8 = b
		return AllowInvalidUTF8(old)
	}
}

// Recover creates an Option to set the recover flag to b. When set to
// true, this causes the parser to recover from panics and convert it
// to an error. Setting it to false can be useful while debugging to
// access the full stack trace.
//
// The default is true.
func Recover(b bool) Option {
	return func(p *parser) Option {
		old := p.recover
		p.recover = b
		return Recover(old)
	}
}

// GlobalStore creates an Option to set a key to a certain value in
// the globalStore.
func GlobalStore(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.globalStore[key]
		p.cur.globalStore[key] = value
		return GlobalStore(key, old)
	}
}

// InitState creates an Option to set a key to a certain value in
// the global "state" store.
func InitState(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.state[key]
		p.cur.state[key] = value
		return InitState(key, old)
	}
}

// ParseFile parses the file identified by filename.
func ParseFile(filename string, opts ...Option) (i any, err error) {
	f, err := os.Open(filename)
	if err != nil {
		return nil, err
	}
	defer func() {
		if closeErr := f.Close(); closeErr != nil {
			err = closeErr
		}
	}()
	return ParseReader(filename, f, opts...)
}

// ParseReader parses the data from r using filename as information in the
// error messages.
func ParseReader(filename string, r io.Reader, opts ...Option) (any, error) {
	b, err := io.ReadAll(r)
	if err != nil {
		return nil, err
	}

	return Parse(filename, b, opts...)
}

// Parse parses the data from b using filename as information in the
// error messages.
func Parse(filename string, b []byte, opts ...Option) (any, error) {
	return newParser(filename, b, opts...).parse(g)
}

// position records a position in the text.
type position struct {
	line, col, offset int
}

func (p position) String() string {
	return strconv.Itoa(p.line) + ":" + strconv.Itoa(p.col) + " [" + strconv.Itoa(p.offset) + "]"
}

// savepoint stores all state required to go back to this point in the
// parser.
type savepoint struct {
	position
	rn rune
	w  int
}

type current struct {
	pos  position // start position of the match
	text []byte   // raw text of the match

	// state is a store for arbitrary key,value pairs that the user wants to be
	// tied to the backtracking of the parser.
	// This is always rolled back if a parsing rule fails.
	state storeDict

	// globalStore is a general store for the user to store arbitrary key-value
	// pairs that they need to manage and that they do not want tied to the
	// backtracking of the parser. This is only modified by the user and never
	// rolled back by the parser. It is always up to the user to keep this in a
	// consistent state.
	globalStore storeDict
}

type storeDict map[string]any

// the AST types...

type grammar struct {
	pos   position
	rules []*rule
}

type rule struct {
	pos         position
	name        string
	displayName string
	expr        any
}

type choiceExpr struct {
	pos          position
	alternatives []any
}

type actionExpr struct {
	pos  position
	expr any
	run  func(*parser) (any, error)
}

type recoveryExpr struct {
	pos          position
	expr         any
	recoverExpr  any
	failureLabel []string
}

type seqExpr struct {
	pos   position
	exprs []any
}

type throwExpr struct {
	pos   position
	label string
}

type labeledExpr struct {
	pos   position
	label string
	expr  any
}

type expr struct {
	pos  position
	expr any
}

type (
	andExpr        expr
	notExpr        expr
	zeroOrOneExpr  expr
	zeroOrMoreExpr expr
	oneOrMoreExpr  expr
)

type ruleRefExpr struct {
	pos  position
	name string
}

type stateCodeExpr struct {
	pos position
	run func(*parser) error
}

type andCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type notCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type litMatcher struct {
	pos        position
	val        string
	ignoreCase bool
	want       string
}

type charClassMatcher struct {
	pos             position
	val             string
	basicLatinChars [128]bool
	chars           []rune
	ranges          []rune
	classes         []*unicode.RangeTable
	ignoreCase      bool
	inverted        bool
}

type anyMatcher position

// errList cumulates the errors found by the parser.
type errList []error

func (e *errList) add(err error) {
	*e = append(*e, err)
}

func (e errList) err() error {
	if len(e) == 0 {
		return nil
	}
	e.dedupe()
	return e
}

func (e *errList) dedupe() {
	var cleaned []error
	set := make(map[string]bool)
	for _, err := range *e {
		if msg := err.Error(); !set[msg] {
			set[msg] = true
			cleaned = append(cleaned, err)
		}
	}
	*e = cleaned
}

func (e errList) Error() string {
	switch len(e) {
	case 0:
		return ""
	case 1:
		return e[0].Error()
	default:
		var buf bytes.Buffer

		for i, err := range e {
			if i > 0 {
				buf.WriteRune('\n')
			}
			buf.WriteString(err.Error())
		}
		return buf.String()
	}
}

// parserError wraps an error with a prefix indicating the rule in which
// the error occurred. The original error is stored in the Inner field.
type parserError struct {
	Inner    error
	pos      position
	prefix   string
	expected []string
}

// Error returns the error message.
func (p *parserError) Error() string {
	return p.prefix + ": " + p.Inner.Error()
}

// newParser creates a parser with the specified input source and options.
func newParser(filename string, b []byte, opts ...Option) *parser {
	stats := Stats{
		ChoiceAltCnt: make(map[string]map[string]int),
	}

	p := &parser{
		filename: filename,
		errs:     new(errList),
		data:     b,
		pt:       savepoint{position: position{line: 1}},
		recover:  true,
		cur: current{
			state:       make(storeDict),
			globalStore: make(storeDict),
		},
		maxFailPos:      position{col: 1, line: 1},
		maxFailExpected: make([]string, 0, 20),
		Stats:           &stats,
		// start rule is rule [0] unless an alternate entrypoint is specified
		entrypoint: g.rules[0].name,
	}
	p.setOptions(opts)

	if p.maxExprCnt == 0 {
		p.maxExprCnt = math.MaxUint64
	}

	return p
}

// setOptions applies the options to the parser.
func (p *parser) setOptions(opts []Option) {
	for _, opt := range opts {
		opt(p)
	}
}

type resultTuple struct {
	v   any
	b   bool
	end savepoint
}

const choiceNoMatch = -1

// Stats stores some statistics, gathered during parsing
type Stats struct {
	// ExprCnt counts the number of expressions processed during parsing
	// This value is compared to the maximum number of expressions allowed
	// (set by the MaxExpressions option).
	ExprCnt uint64

	// ChoiceAltCnt is used to count for each ordered choice expression,
	// which alternative is used how may times.
	// These numbers allow to optimize the order of the ordered choice expression
	// to increase the performance of the parser
	//
	// The outer key of ChoiceAltCnt is composed of the name of the rule as well
	// as the line and the column of the ordered choice.
	// The inner key of ChoiceAltCnt is the number (one-based) of the matching alternative.
	// For each alternative the number of matches are counted. If an ordered choice does not
	// match, a special counter is incremented. The name of this counter is set with
	// the parser option Statistics.
	// For an alternative to be included in ChoiceAltCnt, it has to match at least once.
	ChoiceAltCnt map[string]map[string]int
}

type parser struct {
	filename string
	pt       savepoint
	cur      current

	data []byte
	errs *errList

	depth   int
	recover bool
	debug   bool

	memoize bool
	// memoization table for the packrat algorithm:
	// map[offset in source] map[expression or rule] {value, match}
	memo map[int]map[any]resultTuple

	// rules table, maps the rule identifier to the rule node
	rules map[string]*rule
	// variables stack, map of label to value
	vstack []map[string]any
	// rule stack, allows identification of the current rule in errors
	rstack []*rule

	// parse fail
	maxFailPos            position
	maxFailExpected       []string
	maxFailInvertExpected bool

	// max number of expressions to be parsed
	maxExprCnt uint64
	// entrypoint for the parser
	entrypoint string

	allowInvalidUTF8 bool

	*Stats

	choiceNoMatch string
	// recovery expression stack, keeps track of the currently available recovery expression, these are traversed in reverse
	recoveryStack []map[string]any
}

// push a variable set on the vstack.
func (p *parser) pushV() {
	if cap(p.vstack) == len(p.vstack) {
		// create new empty slot in the stack
		p.vstack = append(p.vstack, nil)
	} else {
		// slice to 1 more
		p.vstack = p.vstack[:len(p.vstack)+1]
	}

	// get the last args set
	m := p.vstack[len(p.vstack)-1]
	if m != nil && len(m) == 0 {
		// empty map, all good
		return
	}

	m = make(map[string]any)
	p.vstack[len(p.vstack)-1] = m
}

// pop a variable set from the vstack.
func (p *parser) popV() {
	// if the map is not empty, clear it
	m := p.vstack[len(p.vstack)-1]
	if len(m) > 0 {
		// GC that map
		p.vstack[len(p.vstack)-1] = nil
	}
	p.vstack = p.vstack[:len(p.vstack)-1]
}

// push a recovery expression with its labels to the recoveryStack
func (p *parser) pushRecovery(labels []string, expr any) {
	if cap(p.recoveryStack) == len(p.recoveryStack) {
		// create new empty slot in the stack
		p.recoveryStack = append(p.recoveryStack, nil)
	} else {
		// slice to 1 more
		p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)+1]
	}

	m := make(map[string]any, len(labels))
	for _, fl := range labels {
		m[fl] = expr
	}
	p.recoveryStack[len(p.recoveryStack)-1] = m
}

// pop a recovery expression from the recoveryStack
func (p *parser) popRecovery() {
	// GC that map
	p.recoveryStack[len(p.recoveryStack)-1] = nil

	p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)-1]
}

func (p *parser) print(prefix, s string) string {
	if !p.debug {
		return s
	}

	fmt.Printf("%s %d:%d:%d: %s [%#U]\n",
		prefix, p.pt.line, p.pt.col, p.pt.offset, s, p.pt.rn)
	return s
}

func (p *parser) printIndent(mark string, s string) string {
	return p.print(strings.Repeat(" ", p.depth)+mark, s)
}

func (p *parser) in(s string) string {
	res := p.printIndent(">", s)
	p.depth++
	return res
}

func (p *parser) out(s string) string {
	p.depth--
	return p.printIndent("<", s)
}

func (p *parser) addErr(err error) {
	p.addErrAt(err, p.pt.position, []string{})
}

func (p *parser) addErrAt(err error, pos position, expected []string) {
	var buf bytes.Buffer
	if p.filename != "" {
		buf.WriteString(p.filename)
	}
	if buf.Len() > 0 {
		buf.WriteString(":")
	}
	buf.WriteString(fmt.Sprintf("%d:%d (%d)", pos.line, pos.col, pos.offset))
	if len(p.rstack) > 0 {
		if buf.Len() > 0 {
			buf.WriteString(": ")
		}
		rule := p.rstack[len(p.rstack)-1]
		if rule.displayName != "" {
			buf.WriteString("rule " + rule.displayName)
		} else {
			buf.WriteString("rule " + rule.name)
		}
	}
	pe := &parserError{Inner: err, pos: pos, prefix: buf.String(), expected: expected}
	p.errs.add(pe)
}

func (p *parser) failAt(fail bool, pos position, want string) {
	// process fail if parsing fails and not inverted or parsing succeeds and invert is set
	if fail == p.maxFailInvertExpected {
		if pos.offset < p.maxFailPos.offset {
			return
		}

		if pos.offset > p.maxFailPos.offset {
			p.maxFailPos = pos
			p.maxFailExpected = p.maxFailExpected[:0]
		}

		if p.maxFailInvertExpected {
			want = "!" + want
		}
		p.maxFailExpected = append(p.maxFailExpected, want)
	}
}

// read advances the parser to the next rune.
func (p *parser) read() {
	p.pt.offset += p.pt.w
	rn, n := utf8.DecodeRune(p.data[p.pt.offset:])
	p.pt.rn = rn
	p.pt.w = n
	p.pt.col++
	if rn == '\n' {
		p.pt.line++
		p.pt.col = 0
	}

	if rn == utf8.RuneError && n == 1 { // see utf8.DecodeRune
		if !p.allowInvalidUTF8 {
			p.addErr(errInvalidEncoding)
		}
	}
}

// restore parser position to the savepoint pt.
func (p *parser) restore(pt savepoint) {
	if p.debug {
		defer p.out(p.in("restore"))
	}
	if pt.offset == p.pt.offset {
		return
	}
	p.pt = pt
}

// Cloner is implemented by any value that has a Clone method, which returns a
// copy of the value. This is mainly used for types which are not passed by
// value (e.g map, slice, chan) or structs that contain such types.
//
// This is used in conjunction with the global state feature to create proper
// copies of the state to allow the parser to properly restore the state in
// the case of backtracking.
type Cloner interface {
	Clone() any
}

var statePool = &sync.Pool{
	New: func() any { return make(storeDict) },
}

func (sd storeDict) Discard() {
	for k := range sd {
		delete(sd, k)
	}
	statePool.Put(sd)
}

// clone and return parser current state.
func (p *parser) cloneState() storeDict {
	if p.debug {
		defer p.out(p.in("cloneState"))
	}

	state := statePool.Get().(storeDict)
	for k, v := range p.cur.state {
		if c, ok := v.(Cloner); ok {
			state[k] = c.Clone()
		} else {
			state[k] = v
		}
	}
	return state
}

// restore parser current state to the state storeDict.
// every restoreState should applied only one time for every cloned state
func (p *parser) restoreState(state storeDict) {
	if p.debug {
		defer p.out(p.in("restoreState"))
	}
	p.cur.state.Discard()
	p.cur.state = state
}

// get the slice of bytes from the savepoint start to the current position.
func (p *parser) sliceFrom(start savepoint) []byte {
	return p.data[start.position.offset:p.pt.position.offset]
}

func (p *parser) getMemoized(node any) (resultTuple, bool) {
	if len(p.memo) == 0 {
		return resultTuple{}, false
	}
	m := p.memo[p.pt.offset]
	if len(m) == 0 {
		return resultTuple{}, false
	}
	res, ok := m[node]
	return res, ok
}

func (p *parser) setMemoized(pt savepoint, node any, tuple resultTuple) {
	if p.memo == nil {
		p.memo = make(map[int]map[any]resultTuple)
	}
	m := p.memo[pt.offset]
	if m == nil {
		m = make(map[any]resultTuple)
		p.memo[pt.offset] = m
	}
	m[node] = tuple
}

func (p *parser) buildRulesTable(g *grammar) {
	p.rules = make(map[string]*rule, len(g.rules))
	for _, r := range g.rules {
		p.rules[r.name] = r
	}
}

func (p *parser) parse(g *grammar) (val any, err error) {
	if len(g.rules) == 0 {
		p.addErr(errNoRule)
		return nil, p.errs.err()
	}

	// TODO : not super critical but this could be generated
	p.buildRulesTable(g)

	if p.recover {
		// panic can be used in action code to stop parsing immediately
		// and return the panic as an error.
		defer func() {
			if e := recover(); e != nil {
				if p.debug {
					defer p.out(p.in("panic handler"))
				}
				val = nil
				switch e := e.(type) {
				case error:
					p.addErr(e)
				default:
					p.addErr(fmt.Errorf("%v", e))
				}
				err = p.errs.err()
			}
		}()
	}

	startRule, ok := p.rules[p.entrypoint]
	if !ok {
		p.addErr(errInvalidEntrypoint)
		return nil, p.errs.err()
	}

	p.read() // advance to first rune
	val, ok = p.parseRuleWrap(startRule)
	if !ok {
		if len(*p.errs) == 0 {
			// If parsing fails, but no errors have been recorded, the expected values
			// for the farthest parser position are returned as error.
			maxFailExpectedMap := make(map[string]struct{}, len(p.maxFailExpected))
			for _, v := range p.maxFailExpected {
				maxFailExpectedMap[v] = struct{}{}
			}
			expected := make([]string, 0, len(maxFailExpectedMap))
			eof := false
			if _, ok := maxFailExpectedMap["!."]; ok {
				delete(maxFailExpectedMap, "!.")
				eof = true
			}
			for k := range maxFailExpectedMap {
				expected = append(expected, k)
			}
			sort.Strings(expected)
			if eof {
				expected = append(expected, "EOF")
			}
			p.addErrAt(errors.New("no match found, expected: "+listJoin(expected, ", ", "or")), p.maxFailPos, expected)
		}

		return nil, p.errs.err()
	}
	return val, p.errs.err()
}

func listJoin(list []string, sep string, lastSep string) string {
	switch len(list) {
	case 0:
		return ""
	case 1:
		return list[0]
	default:
		return strings.Join(list[:len(list)-1], sep) + " " + lastSep + " " + list[len(list)-1]
	}
}

func (p *parser) parseRuleMemoize(rule *rule) (any, bool) {
	res, ok := p.getMemoized(rule)
	if ok {
		p.restore(res.end)
		return res.v, res.b
	}

	startMark := p.pt
	val, ok := p.parseRule(rule)
	p.setMemoized(startMark, rule, resultTuple{val, ok, p.pt})

	return val, ok
}

func (p *parser) parseRuleWrap(rule *rule) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRule " + rule.name))
	}
	var (
		val       any
		ok        bool
		startMark = p.pt
	)

	if p.memoize {
		val, ok = p.parseRuleMemoize(rule)
	} else {
		val, ok = p.parseRule(rule)
	}

	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(startMark)))
	}
	return val, ok
}

func (p *parser) parseRule(rule *rule) (any, bool) {
	p.rstack = append(p.rstack, rule)
	p.pushV()
	val, ok := p.parseExprWrap(rule.expr)
	p.popV()
	p.rstack = p.rstack[:len(p.rstack)-1]
	return val, ok
}

func (p *parser) parseExprWrap(expr any) (any, bool) {
	var pt savepoint

	if p.memoize {
		res, ok := p.getMemoized(expr)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
		pt = p.pt
	}

	val, ok := p.parseExpr(expr)

	if p.memoize {
		p.setMemoized(pt, expr, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseExpr(expr any) (any, bool) {
	p.ExprCnt++
	if p.ExprCnt > p.maxExprCnt {
		panic(errMaxExprCnt)
	}

	var val any
	var ok bool
	switch expr := expr.(type) {
	case *actionExpr:
		val, ok = p.parseActionExpr(expr)
	case *andCodeExpr:
		val, ok = p.parseAndCodeExpr(expr)
	case *andExpr:
		val, ok = p.parseAndExpr(expr)
	case *anyMatcher:
		val, ok = p.parseAnyMatcher(expr)
	case *charClassMatcher:
		val, ok = p.parseCharClassMatcher(expr)
	case *choiceExpr:
		val, ok = p.parseChoiceExpr(expr)
	case *labeledExpr:
		val, ok = p.parseLabeledExpr(expr)
	case *litMatcher:
		val, ok = p.parseLitMatcher(expr)
	case *notCodeExpr:
		val, ok = p.parseNotCodeExpr(expr)
	case *notExpr:
		val, ok = p.parseNotExpr(expr)
	case *oneOrMoreExpr:
		val, ok = p.parseOneOrMoreExpr(expr)
	case *recoveryExpr:
		val, ok = p.parseRecoveryExpr(expr)
	case *ruleRefExpr:
		val, ok = p.parseRuleRefExpr(expr)
	case *seqExpr:
		val, ok = p.parseSeqExpr(expr)
	case *stateCodeExpr:
		val, ok = p.parseStateCodeExpr(expr)
	case *throwExpr:
		val, ok = p.parseThrowExpr(expr)
	case *zeroOrMoreExpr:
		val, ok = p.parseZeroOrMoreExpr(expr)
	case *zeroOrOneExpr:
		val, ok = p.parseZeroOrOneExpr(expr)
	default:
		panic(fmt.Sprintf("unknown expression type %T", expr))
	}
	return val, ok
}

func (p *parser) parseActionExpr(act *actionExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseActionExpr"))
	}

	start := p.pt
	val, ok := p.parseExprWrap(act.expr)
	if ok {
		p.cur.pos = start.position
		p.cur.text = p.sliceFrom(start)
		state := p.cloneState()
		actVal, err := act.run(p)
		if err != nil {
			p.addErrAt(err, start.position, []string{})
		}
		p.restoreState(state)

		val = actVal
	}
	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(start)))
	}
	return val, ok
}

func (p *parser) parseAndCodeExpr(and *andCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndCodeExpr"))
	}

	state := p.cloneState()

	ok, err := and.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, ok
}

func (p *parser) parseAndExpr(and *andExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	_, ok := p.parseExprWrap(and.expr)
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, ok
}

func (p *parser) parseAnyMatcher(any *anyMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAnyMatcher"))
	}

	if p.pt.rn == utf8.RuneError && p.pt.w == 0 {
		// EOF - see utf8.DecodeRune
		p.failAt(false, p.pt.position, ".")
		return nil, false
	}
	start := p.pt
	p.read()
	p.failAt(true, start.position, ".")
	return p.sliceFrom(start), true
}

func (p *parser) parseCharClassMatcher(chr *charClassMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseCharClassMatcher"))
	}

	cur := p.pt.rn
	start := p.pt

	// can't match EOF
	if cur == utf8.RuneError && p.pt.w == 0 { // see utf8.DecodeRune
		p.failAt(false, start.position, chr.val)
		return nil, false
	}

	if chr.ignoreCase {
		cur = unicode.ToLower(cur)
	}

	// try to match in the list of available chars
	for _, rn := range chr.chars {
		if rn == cur {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of ranges
	for i := 0; i < len(chr.ranges); i += 2 {
		if cur >= chr.ranges[i] && cur <= chr.ranges[i+1] {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of Unicode classes
	for _, cl := range chr.classes {
		if unicode.Is(cl, cur) {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	if chr.inverted {
		p.read()
		p.failAt(true, start.position, chr.val)
		return p.sliceFrom(start), true
	}
	p.failAt(false, start.position, chr.val)
	return nil, false
}

func (p *parser) incChoiceAltCnt(ch *choiceExpr, altI int) {
	choiceIdent := fmt.Sprintf("%s %d:%d", p.rstack[len(p.rstack)-1].name, ch.pos.line, ch.pos.col)
	m := p.ChoiceAltCnt[choiceIdent]
	if m == nil {
		m = make(map[string]int)
		p.ChoiceAltCnt[choiceIdent] = m
	}
	// We increment altI by 1, so the keys do not start at 0
	alt := strconv.Itoa(altI + 1)
	if altI == choiceNoMatch {
		alt = p.choiceNoMatch
	}
	m[alt]++
}

func (p *parser) parseChoiceExpr(ch *choiceExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseChoiceExpr"))
	}

	for altI, alt := range ch.alternatives {
		// dummy assignment to prevent compile error if optimized
		_ = altI

		state := p.cloneState()

		p.pushV()
		val, ok := p.parseExprWrap(alt)
		p.popV()
		if ok {
			p.incChoiceAltCnt(ch, altI)
			return val, ok
		}
		p.restoreState(state)
	}
	p.incChoiceAltCnt(ch, choiceNoMatch)
	return nil, false
}

func (p *parser) parseLabeledExpr(lab *labeledExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLabeledExpr"))
	}

	p.pushV()
	val, ok := p.parseExprWrap(lab.expr)
	p.popV()
	if ok && lab.label != "" {
		m := p.vstack[len(p.vstack)-1]
		m[lab.label] = val
	}
	return val, ok
}

func (p *parser) parseLitMatcher(lit *litMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLitMatcher"))
	}

	start := p.pt
	for _, want := range lit.val {
		cur := p.pt.rn
		if lit.ignoreCase {
			cur = unicode.ToLower(cur)
		}
		if cur != want {
			p.failAt(false, start.position, lit.want)
			p.restore(start)
			return nil, false
		}
		p.read()
	}
	p.failAt(true, start.position, lit.want)
	return p.sliceFrom(start), true
}

func (p *parser) parseNotCodeExpr(not *notCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotCodeExpr"))
	}

	state := p.cloneState()

	ok, err := not.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, !ok
}

func (p *parser) parseNotExpr(not *notExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	_, ok := p.parseExprWrap(not.expr)
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, !ok
}

func (p *parser) parseOneOrMoreExpr(expr *oneOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseOneOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			if len(vals) == 0 {
				// did not match once, no match
				return nil, false
			}
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseRecoveryExpr(recover *recoveryExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRecoveryExpr (" + strings.Join(recover.failureLabel, ",") + ")"))
	}

	p.pushRecovery(recover.failureLabel, recover.recoverExpr)
	val, ok := p.parseExprWrap(recover.expr)
	p.popRecovery()

	return val, ok
}

func (p *parser) parseRuleRefExpr(ref *ruleRefExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRuleRefExpr " + ref.name))
	}

	if ref.name == "" {
		panic(fmt.Sprintf("%s: invalid rule: missing name", ref.pos))
	}

	rule := p.rules[ref.name]
	if rule == nil {
		p.addErr(fmt.Errorf("undefined rule: %s", ref.name))
		return nil, false
	}
	return p.parseRuleWrap(rule)
}

func (p *parser) parseSeqExpr(seq *seqExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseSeqExpr"))
	}

	vals := make([]any, 0, len(seq.exprs))

	pt := p.pt
	state := p.cloneState()
	for _, expr := range seq.exprs {
		val, ok := p.parseExprWrap(expr)
		if !ok {
			p.restoreState(state)
			p.restore(pt)
			return nil, false
		}
		vals = append(vals, val)
	}
	return vals, true
}

func (p *parser) parseStateCodeExpr(state *stateCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseStateCodeExpr"))
	}

	err := state.run(p)
	if err != nil {
		p.addErr(err)
	}
	return nil, true
}

func (p *parser) parseThrowExpr(expr *throwExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseThrowExpr"))
	}

	for i := len(p.recoveryStack) - 1; i >= 0; i-- {
		if recoverExpr, ok := p.recoveryStack[i][expr.label]; ok {
			if val, ok := p.parseExprWrap(recoverExpr); ok {
				return val, ok
			}
		}
	}

	return nil, false
}

func (p *parser) parseZeroOrMoreExpr(expr *zeroOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseZeroOrOneExpr(expr *zeroOrOneExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrOneExpr"))
	}

	p.pushV()
	val, _ := p.parseExprWrap(expr.expr)
	p.popV()
	// whether it matched or not, consider it a match
	return val, true
}
